"use strict";
// *** WARNING: this file was generated by pulumigen. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClusterRoleBindingPatch = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("../../utilities");
/**
 * Patch resources are used to modify existing Kubernetes resources by using
 * Server-Side Apply updates. The name of the resource must be specified, but all other properties are optional. More than
 * one patch may be applied to the same resource, and a random FieldManager name will be used for each Patch resource.
 * Conflicts will result in an error by default, but can be forced using the "pulumi.com/patchForce" annotation. See the
 * [Server-Side Apply Docs](https://www.pulumi.com/registry/packages/kubernetes/how-to-guides/managing-resources-with-server-side-apply/) for
 * additional information about using Server-Side Apply to manage Kubernetes resources with Pulumi.
 * ClusterRoleBinding references a ClusterRole, but not contain it.  It can reference a ClusterRole in the global namespace, and adds who information via Subject.
 */
class ClusterRoleBindingPatch extends pulumi.CustomResource {
    /**
     * Get an existing ClusterRoleBindingPatch resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, opts) {
        return new ClusterRoleBindingPatch(name, undefined, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ClusterRoleBindingPatch.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ClusterRoleBindingPatch.__pulumiType;
    }
    /**
     * Create a ClusterRoleBindingPatch resource with the given unique name, arguments, and options.
     *
     * @param name The _unique_ name of the resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param opts A bag of options that control this resource's behavior.
     */
    constructor(name, args, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (!opts.id) {
            resourceInputs["apiVersion"] = "rbac.authorization.k8s.io/v1";
            resourceInputs["kind"] = "ClusterRoleBinding";
            resourceInputs["metadata"] = args ? args.metadata : undefined;
            resourceInputs["roleRef"] = args ? args.roleRef : undefined;
            resourceInputs["subjects"] = args ? args.subjects : undefined;
        }
        else {
            resourceInputs["apiVersion"] = undefined /*out*/;
            resourceInputs["kind"] = undefined /*out*/;
            resourceInputs["metadata"] = undefined /*out*/;
            resourceInputs["roleRef"] = undefined /*out*/;
            resourceInputs["subjects"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const aliasOpts = { aliases: [{ type: "kubernetes:rbac.authorization.k8s.io/v1alpha1:ClusterRoleBindingPatch" }, { type: "kubernetes:rbac.authorization.k8s.io/v1beta1:ClusterRoleBindingPatch" }] };
        opts = pulumi.mergeOptions(opts, aliasOpts);
        super(ClusterRoleBindingPatch.__pulumiType, name, resourceInputs, opts);
    }
}
exports.ClusterRoleBindingPatch = ClusterRoleBindingPatch;
/** @internal */
ClusterRoleBindingPatch.__pulumiType = 'kubernetes:rbac.authorization.k8s.io/v1:ClusterRoleBindingPatch';
//# sourceMappingURL=clusterRoleBindingPatch.js.map