import * as pulumi from "@pulumi/pulumi";
import * as admissionregistration from "../admissionregistration";
import * as apiextensions from "../apiextensions";
import * as apiregistration from "../apiregistration";
import * as apps from "../apps";
import * as auditregistration from "../auditregistration";
import * as autoscaling from "../autoscaling";
import * as batch from "../batch";
import * as certificates from "../certificates";
import * as coordination from "../coordination";
import * as core from "../core";
import * as discovery from "../discovery";
import * as events from "../events";
import * as extensions from "../extensions";
import * as flowcontrol from "../flowcontrol";
import * as meta from "../meta";
import * as networking from "../networking";
import * as node from "../node";
import * as policy from "../policy";
import * as rbac from "../rbac";
import * as resource from "../resource";
import * as scheduling from "../scheduling";
import * as settings from "../settings";
import * as storage from "../storage";
import * as storagemigration from "../storagemigration";
import * as outputs from "../types/output";
export declare abstract class CollectionComponentResource extends pulumi.ComponentResource {
    resources: pulumi.Output<{
        [key: string]: pulumi.CustomResource;
    }>;
    ready: pulumi.Output<pulumi.CustomResource[]>;
    protected constructor(resourceType: string, name: string, config: any, opts?: pulumi.ComponentResourceOptions);
    /**
     * getResource returns a resource defined by a built-in Kubernetes group/version/kind and name.
     *
     * For example:
     *     getResource("apps/v1/Deployment", "nginx")
     */
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", name: string): pulumi.Output<admissionregistration.v1.MutatingWebhookConfiguration>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", namespace: string, name: string): pulumi.Output<admissionregistration.v1.MutatingWebhookConfiguration>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", name: string): pulumi.Output<admissionregistration.v1.MutatingWebhookConfigurationList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", namespace: string, name: string): pulumi.Output<admissionregistration.v1.MutatingWebhookConfigurationList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", name: string): pulumi.Output<admissionregistration.v1.ValidatingAdmissionPolicy>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", namespace: string, name: string): pulumi.Output<admissionregistration.v1.ValidatingAdmissionPolicy>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", name: string): pulumi.Output<admissionregistration.v1.ValidatingAdmissionPolicyBinding>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", namespace: string, name: string): pulumi.Output<admissionregistration.v1.ValidatingAdmissionPolicyBinding>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", name: string): pulumi.Output<admissionregistration.v1.ValidatingAdmissionPolicyBindingList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string): pulumi.Output<admissionregistration.v1.ValidatingAdmissionPolicyBindingList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", name: string): pulumi.Output<admissionregistration.v1.ValidatingAdmissionPolicyList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", namespace: string, name: string): pulumi.Output<admissionregistration.v1.ValidatingAdmissionPolicyList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", name: string): pulumi.Output<admissionregistration.v1.ValidatingWebhookConfiguration>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", namespace: string, name: string): pulumi.Output<admissionregistration.v1.ValidatingWebhookConfiguration>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", name: string): pulumi.Output<admissionregistration.v1.ValidatingWebhookConfigurationList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", namespace: string, name: string): pulumi.Output<admissionregistration.v1.ValidatingWebhookConfigurationList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", name: string): pulumi.Output<admissionregistration.v1alpha1.MutatingAdmissionPolicy>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", namespace: string, name: string): pulumi.Output<admissionregistration.v1alpha1.MutatingAdmissionPolicy>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", name: string): pulumi.Output<admissionregistration.v1alpha1.MutatingAdmissionPolicyBinding>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", namespace: string, name: string): pulumi.Output<admissionregistration.v1alpha1.MutatingAdmissionPolicyBinding>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", name: string): pulumi.Output<admissionregistration.v1alpha1.MutatingAdmissionPolicyBindingList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", namespace: string, name: string): pulumi.Output<admissionregistration.v1alpha1.MutatingAdmissionPolicyBindingList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", name: string): pulumi.Output<admissionregistration.v1alpha1.MutatingAdmissionPolicyList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", namespace: string, name: string): pulumi.Output<admissionregistration.v1alpha1.MutatingAdmissionPolicyList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", name: string): pulumi.Output<admissionregistration.v1alpha1.ValidatingAdmissionPolicy>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", namespace: string, name: string): pulumi.Output<admissionregistration.v1alpha1.ValidatingAdmissionPolicy>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", name: string): pulumi.Output<admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", namespace: string, name: string): pulumi.Output<admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", name: string): pulumi.Output<admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string): pulumi.Output<admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", name: string): pulumi.Output<admissionregistration.v1alpha1.ValidatingAdmissionPolicyList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", namespace: string, name: string): pulumi.Output<admissionregistration.v1alpha1.ValidatingAdmissionPolicyList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", name: string): pulumi.Output<admissionregistration.v1beta1.MutatingWebhookConfiguration>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", namespace: string, name: string): pulumi.Output<admissionregistration.v1beta1.MutatingWebhookConfiguration>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", name: string): pulumi.Output<admissionregistration.v1beta1.MutatingWebhookConfigurationList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", namespace: string, name: string): pulumi.Output<admissionregistration.v1beta1.MutatingWebhookConfigurationList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingAdmissionPolicy>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", namespace: string, name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingAdmissionPolicy>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", namespace: string, name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingAdmissionPolicyList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", namespace: string, name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingAdmissionPolicyList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingWebhookConfiguration>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", namespace: string, name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingWebhookConfiguration>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingWebhookConfigurationList>;
    getResource(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", namespace: string, name: string): pulumi.Output<admissionregistration.v1beta1.ValidatingWebhookConfigurationList>;
    getResource(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", name: string): pulumi.Output<apiextensions.v1.CustomResourceDefinition>;
    getResource(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", namespace: string, name: string): pulumi.Output<apiextensions.v1.CustomResourceDefinition>;
    getResource(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", name: string): pulumi.Output<apiextensions.v1.CustomResourceDefinitionList>;
    getResource(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", namespace: string, name: string): pulumi.Output<apiextensions.v1.CustomResourceDefinitionList>;
    getResource(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", name: string): pulumi.Output<apiextensions.v1beta1.CustomResourceDefinition>;
    getResource(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", namespace: string, name: string): pulumi.Output<apiextensions.v1beta1.CustomResourceDefinition>;
    getResource(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", name: string): pulumi.Output<apiextensions.v1beta1.CustomResourceDefinitionList>;
    getResource(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", namespace: string, name: string): pulumi.Output<apiextensions.v1beta1.CustomResourceDefinitionList>;
    getResource(groupVersionKind: "apiregistration.k8s.io/v1/APIService", name: string): pulumi.Output<apiregistration.v1.APIService>;
    getResource(groupVersionKind: "apiregistration.k8s.io/v1/APIService", namespace: string, name: string): pulumi.Output<apiregistration.v1.APIService>;
    getResource(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", name: string): pulumi.Output<apiregistration.v1.APIServiceList>;
    getResource(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", namespace: string, name: string): pulumi.Output<apiregistration.v1.APIServiceList>;
    getResource(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", name: string): pulumi.Output<apiregistration.v1beta1.APIService>;
    getResource(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", namespace: string, name: string): pulumi.Output<apiregistration.v1beta1.APIService>;
    getResource(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", name: string): pulumi.Output<apiregistration.v1beta1.APIServiceList>;
    getResource(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", namespace: string, name: string): pulumi.Output<apiregistration.v1beta1.APIServiceList>;
    getResource(groupVersionKind: "apps/v1/ControllerRevision", name: string): pulumi.Output<apps.v1.ControllerRevision>;
    getResource(groupVersionKind: "apps/v1/ControllerRevision", namespace: string, name: string): pulumi.Output<apps.v1.ControllerRevision>;
    getResource(groupVersionKind: "apps/v1/ControllerRevisionList", name: string): pulumi.Output<apps.v1.ControllerRevisionList>;
    getResource(groupVersionKind: "apps/v1/ControllerRevisionList", namespace: string, name: string): pulumi.Output<apps.v1.ControllerRevisionList>;
    getResource(groupVersionKind: "apps/v1/DaemonSet", name: string): pulumi.Output<apps.v1.DaemonSet>;
    getResource(groupVersionKind: "apps/v1/DaemonSet", namespace: string, name: string): pulumi.Output<apps.v1.DaemonSet>;
    getResource(groupVersionKind: "apps/v1/DaemonSetList", name: string): pulumi.Output<apps.v1.DaemonSetList>;
    getResource(groupVersionKind: "apps/v1/DaemonSetList", namespace: string, name: string): pulumi.Output<apps.v1.DaemonSetList>;
    getResource(groupVersionKind: "apps/v1/Deployment", name: string): pulumi.Output<apps.v1.Deployment>;
    getResource(groupVersionKind: "apps/v1/Deployment", namespace: string, name: string): pulumi.Output<apps.v1.Deployment>;
    getResource(groupVersionKind: "apps/v1/DeploymentList", name: string): pulumi.Output<apps.v1.DeploymentList>;
    getResource(groupVersionKind: "apps/v1/DeploymentList", namespace: string, name: string): pulumi.Output<apps.v1.DeploymentList>;
    getResource(groupVersionKind: "apps/v1/ReplicaSet", name: string): pulumi.Output<apps.v1.ReplicaSet>;
    getResource(groupVersionKind: "apps/v1/ReplicaSet", namespace: string, name: string): pulumi.Output<apps.v1.ReplicaSet>;
    getResource(groupVersionKind: "apps/v1/ReplicaSetList", name: string): pulumi.Output<apps.v1.ReplicaSetList>;
    getResource(groupVersionKind: "apps/v1/ReplicaSetList", namespace: string, name: string): pulumi.Output<apps.v1.ReplicaSetList>;
    getResource(groupVersionKind: "apps/v1/StatefulSet", name: string): pulumi.Output<apps.v1.StatefulSet>;
    getResource(groupVersionKind: "apps/v1/StatefulSet", namespace: string, name: string): pulumi.Output<apps.v1.StatefulSet>;
    getResource(groupVersionKind: "apps/v1/StatefulSetList", name: string): pulumi.Output<apps.v1.StatefulSetList>;
    getResource(groupVersionKind: "apps/v1/StatefulSetList", namespace: string, name: string): pulumi.Output<apps.v1.StatefulSetList>;
    getResource(groupVersionKind: "apps/v1beta1/ControllerRevision", name: string): pulumi.Output<apps.v1beta1.ControllerRevision>;
    getResource(groupVersionKind: "apps/v1beta1/ControllerRevision", namespace: string, name: string): pulumi.Output<apps.v1beta1.ControllerRevision>;
    getResource(groupVersionKind: "apps/v1beta1/ControllerRevisionList", name: string): pulumi.Output<apps.v1beta1.ControllerRevisionList>;
    getResource(groupVersionKind: "apps/v1beta1/ControllerRevisionList", namespace: string, name: string): pulumi.Output<apps.v1beta1.ControllerRevisionList>;
    getResource(groupVersionKind: "apps/v1beta1/Deployment", name: string): pulumi.Output<apps.v1beta1.Deployment>;
    getResource(groupVersionKind: "apps/v1beta1/Deployment", namespace: string, name: string): pulumi.Output<apps.v1beta1.Deployment>;
    getResource(groupVersionKind: "apps/v1beta1/DeploymentList", name: string): pulumi.Output<apps.v1beta1.DeploymentList>;
    getResource(groupVersionKind: "apps/v1beta1/DeploymentList", namespace: string, name: string): pulumi.Output<apps.v1beta1.DeploymentList>;
    getResource(groupVersionKind: "apps/v1beta1/StatefulSet", name: string): pulumi.Output<apps.v1beta1.StatefulSet>;
    getResource(groupVersionKind: "apps/v1beta1/StatefulSet", namespace: string, name: string): pulumi.Output<apps.v1beta1.StatefulSet>;
    getResource(groupVersionKind: "apps/v1beta1/StatefulSetList", name: string): pulumi.Output<apps.v1beta1.StatefulSetList>;
    getResource(groupVersionKind: "apps/v1beta1/StatefulSetList", namespace: string, name: string): pulumi.Output<apps.v1beta1.StatefulSetList>;
    getResource(groupVersionKind: "apps/v1beta2/ControllerRevision", name: string): pulumi.Output<apps.v1beta2.ControllerRevision>;
    getResource(groupVersionKind: "apps/v1beta2/ControllerRevision", namespace: string, name: string): pulumi.Output<apps.v1beta2.ControllerRevision>;
    getResource(groupVersionKind: "apps/v1beta2/ControllerRevisionList", name: string): pulumi.Output<apps.v1beta2.ControllerRevisionList>;
    getResource(groupVersionKind: "apps/v1beta2/ControllerRevisionList", namespace: string, name: string): pulumi.Output<apps.v1beta2.ControllerRevisionList>;
    getResource(groupVersionKind: "apps/v1beta2/DaemonSet", name: string): pulumi.Output<apps.v1beta2.DaemonSet>;
    getResource(groupVersionKind: "apps/v1beta2/DaemonSet", namespace: string, name: string): pulumi.Output<apps.v1beta2.DaemonSet>;
    getResource(groupVersionKind: "apps/v1beta2/DaemonSetList", name: string): pulumi.Output<apps.v1beta2.DaemonSetList>;
    getResource(groupVersionKind: "apps/v1beta2/DaemonSetList", namespace: string, name: string): pulumi.Output<apps.v1beta2.DaemonSetList>;
    getResource(groupVersionKind: "apps/v1beta2/Deployment", name: string): pulumi.Output<apps.v1beta2.Deployment>;
    getResource(groupVersionKind: "apps/v1beta2/Deployment", namespace: string, name: string): pulumi.Output<apps.v1beta2.Deployment>;
    getResource(groupVersionKind: "apps/v1beta2/DeploymentList", name: string): pulumi.Output<apps.v1beta2.DeploymentList>;
    getResource(groupVersionKind: "apps/v1beta2/DeploymentList", namespace: string, name: string): pulumi.Output<apps.v1beta2.DeploymentList>;
    getResource(groupVersionKind: "apps/v1beta2/ReplicaSet", name: string): pulumi.Output<apps.v1beta2.ReplicaSet>;
    getResource(groupVersionKind: "apps/v1beta2/ReplicaSet", namespace: string, name: string): pulumi.Output<apps.v1beta2.ReplicaSet>;
    getResource(groupVersionKind: "apps/v1beta2/ReplicaSetList", name: string): pulumi.Output<apps.v1beta2.ReplicaSetList>;
    getResource(groupVersionKind: "apps/v1beta2/ReplicaSetList", namespace: string, name: string): pulumi.Output<apps.v1beta2.ReplicaSetList>;
    getResource(groupVersionKind: "apps/v1beta2/StatefulSet", name: string): pulumi.Output<apps.v1beta2.StatefulSet>;
    getResource(groupVersionKind: "apps/v1beta2/StatefulSet", namespace: string, name: string): pulumi.Output<apps.v1beta2.StatefulSet>;
    getResource(groupVersionKind: "apps/v1beta2/StatefulSetList", name: string): pulumi.Output<apps.v1beta2.StatefulSetList>;
    getResource(groupVersionKind: "apps/v1beta2/StatefulSetList", namespace: string, name: string): pulumi.Output<apps.v1beta2.StatefulSetList>;
    getResource(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", name: string): pulumi.Output<auditregistration.v1alpha1.AuditSink>;
    getResource(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", namespace: string, name: string): pulumi.Output<auditregistration.v1alpha1.AuditSink>;
    getResource(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", name: string): pulumi.Output<auditregistration.v1alpha1.AuditSinkList>;
    getResource(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", namespace: string, name: string): pulumi.Output<auditregistration.v1alpha1.AuditSinkList>;
    getResource(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", name: string): pulumi.Output<autoscaling.v1.HorizontalPodAutoscaler>;
    getResource(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", namespace: string, name: string): pulumi.Output<autoscaling.v1.HorizontalPodAutoscaler>;
    getResource(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", name: string): pulumi.Output<autoscaling.v1.HorizontalPodAutoscalerList>;
    getResource(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", namespace: string, name: string): pulumi.Output<autoscaling.v1.HorizontalPodAutoscalerList>;
    getResource(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", name: string): pulumi.Output<autoscaling.v2.HorizontalPodAutoscaler>;
    getResource(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", namespace: string, name: string): pulumi.Output<autoscaling.v2.HorizontalPodAutoscaler>;
    getResource(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", name: string): pulumi.Output<autoscaling.v2.HorizontalPodAutoscalerList>;
    getResource(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", namespace: string, name: string): pulumi.Output<autoscaling.v2.HorizontalPodAutoscalerList>;
    getResource(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", name: string): pulumi.Output<autoscaling.v2beta1.HorizontalPodAutoscaler>;
    getResource(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", namespace: string, name: string): pulumi.Output<autoscaling.v2beta1.HorizontalPodAutoscaler>;
    getResource(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", name: string): pulumi.Output<autoscaling.v2beta1.HorizontalPodAutoscalerList>;
    getResource(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", namespace: string, name: string): pulumi.Output<autoscaling.v2beta1.HorizontalPodAutoscalerList>;
    getResource(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", name: string): pulumi.Output<autoscaling.v2beta2.HorizontalPodAutoscaler>;
    getResource(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", namespace: string, name: string): pulumi.Output<autoscaling.v2beta2.HorizontalPodAutoscaler>;
    getResource(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", name: string): pulumi.Output<autoscaling.v2beta2.HorizontalPodAutoscalerList>;
    getResource(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", namespace: string, name: string): pulumi.Output<autoscaling.v2beta2.HorizontalPodAutoscalerList>;
    getResource(groupVersionKind: "batch/v1/CronJob", name: string): pulumi.Output<batch.v1.CronJob>;
    getResource(groupVersionKind: "batch/v1/CronJob", namespace: string, name: string): pulumi.Output<batch.v1.CronJob>;
    getResource(groupVersionKind: "batch/v1/CronJobList", name: string): pulumi.Output<batch.v1.CronJobList>;
    getResource(groupVersionKind: "batch/v1/CronJobList", namespace: string, name: string): pulumi.Output<batch.v1.CronJobList>;
    getResource(groupVersionKind: "batch/v1/Job", name: string): pulumi.Output<batch.v1.Job>;
    getResource(groupVersionKind: "batch/v1/Job", namespace: string, name: string): pulumi.Output<batch.v1.Job>;
    getResource(groupVersionKind: "batch/v1/JobList", name: string): pulumi.Output<batch.v1.JobList>;
    getResource(groupVersionKind: "batch/v1/JobList", namespace: string, name: string): pulumi.Output<batch.v1.JobList>;
    getResource(groupVersionKind: "batch/v1beta1/CronJob", name: string): pulumi.Output<batch.v1beta1.CronJob>;
    getResource(groupVersionKind: "batch/v1beta1/CronJob", namespace: string, name: string): pulumi.Output<batch.v1beta1.CronJob>;
    getResource(groupVersionKind: "batch/v1beta1/CronJobList", name: string): pulumi.Output<batch.v1beta1.CronJobList>;
    getResource(groupVersionKind: "batch/v1beta1/CronJobList", namespace: string, name: string): pulumi.Output<batch.v1beta1.CronJobList>;
    getResource(groupVersionKind: "batch/v2alpha1/CronJob", name: string): pulumi.Output<batch.v2alpha1.CronJob>;
    getResource(groupVersionKind: "batch/v2alpha1/CronJob", namespace: string, name: string): pulumi.Output<batch.v2alpha1.CronJob>;
    getResource(groupVersionKind: "batch/v2alpha1/CronJobList", name: string): pulumi.Output<batch.v2alpha1.CronJobList>;
    getResource(groupVersionKind: "batch/v2alpha1/CronJobList", namespace: string, name: string): pulumi.Output<batch.v2alpha1.CronJobList>;
    getResource(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", name: string): pulumi.Output<certificates.v1.CertificateSigningRequest>;
    getResource(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", namespace: string, name: string): pulumi.Output<certificates.v1.CertificateSigningRequest>;
    getResource(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", name: string): pulumi.Output<certificates.v1.CertificateSigningRequestList>;
    getResource(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", namespace: string, name: string): pulumi.Output<certificates.v1.CertificateSigningRequestList>;
    getResource(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", name: string): pulumi.Output<certificates.v1alpha1.ClusterTrustBundle>;
    getResource(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", namespace: string, name: string): pulumi.Output<certificates.v1alpha1.ClusterTrustBundle>;
    getResource(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", name: string): pulumi.Output<certificates.v1alpha1.ClusterTrustBundleList>;
    getResource(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", namespace: string, name: string): pulumi.Output<certificates.v1alpha1.ClusterTrustBundleList>;
    getResource(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", name: string): pulumi.Output<certificates.v1beta1.CertificateSigningRequest>;
    getResource(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", namespace: string, name: string): pulumi.Output<certificates.v1beta1.CertificateSigningRequest>;
    getResource(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", name: string): pulumi.Output<certificates.v1beta1.CertificateSigningRequestList>;
    getResource(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", namespace: string, name: string): pulumi.Output<certificates.v1beta1.CertificateSigningRequestList>;
    getResource(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", name: string): pulumi.Output<certificates.v1beta1.ClusterTrustBundle>;
    getResource(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", namespace: string, name: string): pulumi.Output<certificates.v1beta1.ClusterTrustBundle>;
    getResource(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", name: string): pulumi.Output<certificates.v1beta1.ClusterTrustBundleList>;
    getResource(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", namespace: string, name: string): pulumi.Output<certificates.v1beta1.ClusterTrustBundleList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1/Lease", name: string): pulumi.Output<coordination.v1.Lease>;
    getResource(groupVersionKind: "coordination.k8s.io/v1/Lease", namespace: string, name: string): pulumi.Output<coordination.v1.Lease>;
    getResource(groupVersionKind: "coordination.k8s.io/v1/LeaseList", name: string): pulumi.Output<coordination.v1.LeaseList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1/LeaseList", namespace: string, name: string): pulumi.Output<coordination.v1.LeaseList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", name: string): pulumi.Output<coordination.v1alpha1.LeaseCandidate>;
    getResource(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", namespace: string, name: string): pulumi.Output<coordination.v1alpha1.LeaseCandidate>;
    getResource(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", name: string): pulumi.Output<coordination.v1alpha1.LeaseCandidateList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", namespace: string, name: string): pulumi.Output<coordination.v1alpha1.LeaseCandidateList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", name: string): pulumi.Output<coordination.v1alpha2.LeaseCandidate>;
    getResource(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", namespace: string, name: string): pulumi.Output<coordination.v1alpha2.LeaseCandidate>;
    getResource(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", name: string): pulumi.Output<coordination.v1alpha2.LeaseCandidateList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", namespace: string, name: string): pulumi.Output<coordination.v1alpha2.LeaseCandidateList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", name: string): pulumi.Output<coordination.v1beta1.Lease>;
    getResource(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", namespace: string, name: string): pulumi.Output<coordination.v1beta1.Lease>;
    getResource(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", name: string): pulumi.Output<coordination.v1beta1.LeaseCandidate>;
    getResource(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", namespace: string, name: string): pulumi.Output<coordination.v1beta1.LeaseCandidate>;
    getResource(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", name: string): pulumi.Output<coordination.v1beta1.LeaseCandidateList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", namespace: string, name: string): pulumi.Output<coordination.v1beta1.LeaseCandidateList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", name: string): pulumi.Output<coordination.v1beta1.LeaseList>;
    getResource(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", namespace: string, name: string): pulumi.Output<coordination.v1beta1.LeaseList>;
    getResource(groupVersionKind: "v1/Binding", name: string): pulumi.Output<core.v1.Binding>;
    getResource(groupVersionKind: "v1/Binding", namespace: string, name: string): pulumi.Output<core.v1.Binding>;
    getResource(groupVersionKind: "v1/ConfigMap", name: string): pulumi.Output<core.v1.ConfigMap>;
    getResource(groupVersionKind: "v1/ConfigMap", namespace: string, name: string): pulumi.Output<core.v1.ConfigMap>;
    getResource(groupVersionKind: "v1/ConfigMapList", name: string): pulumi.Output<core.v1.ConfigMapList>;
    getResource(groupVersionKind: "v1/ConfigMapList", namespace: string, name: string): pulumi.Output<core.v1.ConfigMapList>;
    getResource(groupVersionKind: "v1/Endpoints", name: string): pulumi.Output<core.v1.Endpoints>;
    getResource(groupVersionKind: "v1/Endpoints", namespace: string, name: string): pulumi.Output<core.v1.Endpoints>;
    getResource(groupVersionKind: "v1/EndpointsList", name: string): pulumi.Output<core.v1.EndpointsList>;
    getResource(groupVersionKind: "v1/EndpointsList", namespace: string, name: string): pulumi.Output<core.v1.EndpointsList>;
    getResource(groupVersionKind: "v1/Event", name: string): pulumi.Output<core.v1.Event>;
    getResource(groupVersionKind: "v1/Event", namespace: string, name: string): pulumi.Output<core.v1.Event>;
    getResource(groupVersionKind: "v1/EventList", name: string): pulumi.Output<core.v1.EventList>;
    getResource(groupVersionKind: "v1/EventList", namespace: string, name: string): pulumi.Output<core.v1.EventList>;
    getResource(groupVersionKind: "v1/LimitRange", name: string): pulumi.Output<core.v1.LimitRange>;
    getResource(groupVersionKind: "v1/LimitRange", namespace: string, name: string): pulumi.Output<core.v1.LimitRange>;
    getResource(groupVersionKind: "v1/LimitRangeList", name: string): pulumi.Output<core.v1.LimitRangeList>;
    getResource(groupVersionKind: "v1/LimitRangeList", namespace: string, name: string): pulumi.Output<core.v1.LimitRangeList>;
    getResource(groupVersionKind: "v1/Namespace", name: string): pulumi.Output<core.v1.Namespace>;
    getResource(groupVersionKind: "v1/Namespace", namespace: string, name: string): pulumi.Output<core.v1.Namespace>;
    getResource(groupVersionKind: "v1/NamespaceList", name: string): pulumi.Output<core.v1.NamespaceList>;
    getResource(groupVersionKind: "v1/NamespaceList", namespace: string, name: string): pulumi.Output<core.v1.NamespaceList>;
    getResource(groupVersionKind: "v1/Node", name: string): pulumi.Output<core.v1.Node>;
    getResource(groupVersionKind: "v1/Node", namespace: string, name: string): pulumi.Output<core.v1.Node>;
    getResource(groupVersionKind: "v1/NodeList", name: string): pulumi.Output<core.v1.NodeList>;
    getResource(groupVersionKind: "v1/NodeList", namespace: string, name: string): pulumi.Output<core.v1.NodeList>;
    getResource(groupVersionKind: "v1/PersistentVolume", name: string): pulumi.Output<core.v1.PersistentVolume>;
    getResource(groupVersionKind: "v1/PersistentVolume", namespace: string, name: string): pulumi.Output<core.v1.PersistentVolume>;
    getResource(groupVersionKind: "v1/PersistentVolumeClaim", name: string): pulumi.Output<core.v1.PersistentVolumeClaim>;
    getResource(groupVersionKind: "v1/PersistentVolumeClaim", namespace: string, name: string): pulumi.Output<core.v1.PersistentVolumeClaim>;
    getResource(groupVersionKind: "v1/PersistentVolumeClaimList", name: string): pulumi.Output<core.v1.PersistentVolumeClaimList>;
    getResource(groupVersionKind: "v1/PersistentVolumeClaimList", namespace: string, name: string): pulumi.Output<core.v1.PersistentVolumeClaimList>;
    getResource(groupVersionKind: "v1/PersistentVolumeList", name: string): pulumi.Output<core.v1.PersistentVolumeList>;
    getResource(groupVersionKind: "v1/PersistentVolumeList", namespace: string, name: string): pulumi.Output<core.v1.PersistentVolumeList>;
    getResource(groupVersionKind: "v1/Pod", name: string): pulumi.Output<core.v1.Pod>;
    getResource(groupVersionKind: "v1/Pod", namespace: string, name: string): pulumi.Output<core.v1.Pod>;
    getResource(groupVersionKind: "v1/PodList", name: string): pulumi.Output<core.v1.PodList>;
    getResource(groupVersionKind: "v1/PodList", namespace: string, name: string): pulumi.Output<core.v1.PodList>;
    getResource(groupVersionKind: "v1/PodTemplate", name: string): pulumi.Output<core.v1.PodTemplate>;
    getResource(groupVersionKind: "v1/PodTemplate", namespace: string, name: string): pulumi.Output<core.v1.PodTemplate>;
    getResource(groupVersionKind: "v1/PodTemplateList", name: string): pulumi.Output<core.v1.PodTemplateList>;
    getResource(groupVersionKind: "v1/PodTemplateList", namespace: string, name: string): pulumi.Output<core.v1.PodTemplateList>;
    getResource(groupVersionKind: "v1/ReplicationController", name: string): pulumi.Output<core.v1.ReplicationController>;
    getResource(groupVersionKind: "v1/ReplicationController", namespace: string, name: string): pulumi.Output<core.v1.ReplicationController>;
    getResource(groupVersionKind: "v1/ReplicationControllerList", name: string): pulumi.Output<core.v1.ReplicationControllerList>;
    getResource(groupVersionKind: "v1/ReplicationControllerList", namespace: string, name: string): pulumi.Output<core.v1.ReplicationControllerList>;
    getResource(groupVersionKind: "v1/ResourceQuota", name: string): pulumi.Output<core.v1.ResourceQuota>;
    getResource(groupVersionKind: "v1/ResourceQuota", namespace: string, name: string): pulumi.Output<core.v1.ResourceQuota>;
    getResource(groupVersionKind: "v1/ResourceQuotaList", name: string): pulumi.Output<core.v1.ResourceQuotaList>;
    getResource(groupVersionKind: "v1/ResourceQuotaList", namespace: string, name: string): pulumi.Output<core.v1.ResourceQuotaList>;
    getResource(groupVersionKind: "v1/Secret", name: string): pulumi.Output<core.v1.Secret>;
    getResource(groupVersionKind: "v1/Secret", namespace: string, name: string): pulumi.Output<core.v1.Secret>;
    getResource(groupVersionKind: "v1/SecretList", name: string): pulumi.Output<core.v1.SecretList>;
    getResource(groupVersionKind: "v1/SecretList", namespace: string, name: string): pulumi.Output<core.v1.SecretList>;
    getResource(groupVersionKind: "v1/Service", name: string): pulumi.Output<core.v1.Service>;
    getResource(groupVersionKind: "v1/Service", namespace: string, name: string): pulumi.Output<core.v1.Service>;
    getResource(groupVersionKind: "v1/ServiceAccount", name: string): pulumi.Output<core.v1.ServiceAccount>;
    getResource(groupVersionKind: "v1/ServiceAccount", namespace: string, name: string): pulumi.Output<core.v1.ServiceAccount>;
    getResource(groupVersionKind: "v1/ServiceAccountList", name: string): pulumi.Output<core.v1.ServiceAccountList>;
    getResource(groupVersionKind: "v1/ServiceAccountList", namespace: string, name: string): pulumi.Output<core.v1.ServiceAccountList>;
    getResource(groupVersionKind: "v1/ServiceList", name: string): pulumi.Output<core.v1.ServiceList>;
    getResource(groupVersionKind: "v1/ServiceList", namespace: string, name: string): pulumi.Output<core.v1.ServiceList>;
    getResource(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", name: string): pulumi.Output<discovery.v1.EndpointSlice>;
    getResource(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", namespace: string, name: string): pulumi.Output<discovery.v1.EndpointSlice>;
    getResource(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", name: string): pulumi.Output<discovery.v1.EndpointSliceList>;
    getResource(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", namespace: string, name: string): pulumi.Output<discovery.v1.EndpointSliceList>;
    getResource(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", name: string): pulumi.Output<discovery.v1beta1.EndpointSlice>;
    getResource(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", namespace: string, name: string): pulumi.Output<discovery.v1beta1.EndpointSlice>;
    getResource(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", name: string): pulumi.Output<discovery.v1beta1.EndpointSliceList>;
    getResource(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", namespace: string, name: string): pulumi.Output<discovery.v1beta1.EndpointSliceList>;
    getResource(groupVersionKind: "events.k8s.io/v1/Event", name: string): pulumi.Output<events.v1.Event>;
    getResource(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string): pulumi.Output<events.v1.Event>;
    getResource(groupVersionKind: "events.k8s.io/v1/EventList", name: string): pulumi.Output<events.v1.EventList>;
    getResource(groupVersionKind: "events.k8s.io/v1/EventList", namespace: string, name: string): pulumi.Output<events.v1.EventList>;
    getResource(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string): pulumi.Output<events.v1beta1.Event>;
    getResource(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string): pulumi.Output<events.v1beta1.Event>;
    getResource(groupVersionKind: "events.k8s.io/v1beta1/EventList", name: string): pulumi.Output<events.v1beta1.EventList>;
    getResource(groupVersionKind: "events.k8s.io/v1beta1/EventList", namespace: string, name: string): pulumi.Output<events.v1beta1.EventList>;
    getResource(groupVersionKind: "extensions/v1beta1/DaemonSet", name: string): pulumi.Output<extensions.v1beta1.DaemonSet>;
    getResource(groupVersionKind: "extensions/v1beta1/DaemonSet", namespace: string, name: string): pulumi.Output<extensions.v1beta1.DaemonSet>;
    getResource(groupVersionKind: "extensions/v1beta1/DaemonSetList", name: string): pulumi.Output<extensions.v1beta1.DaemonSetList>;
    getResource(groupVersionKind: "extensions/v1beta1/DaemonSetList", namespace: string, name: string): pulumi.Output<extensions.v1beta1.DaemonSetList>;
    getResource(groupVersionKind: "extensions/v1beta1/Deployment", name: string): pulumi.Output<extensions.v1beta1.Deployment>;
    getResource(groupVersionKind: "extensions/v1beta1/Deployment", namespace: string, name: string): pulumi.Output<extensions.v1beta1.Deployment>;
    getResource(groupVersionKind: "extensions/v1beta1/DeploymentList", name: string): pulumi.Output<extensions.v1beta1.DeploymentList>;
    getResource(groupVersionKind: "extensions/v1beta1/DeploymentList", namespace: string, name: string): pulumi.Output<extensions.v1beta1.DeploymentList>;
    getResource(groupVersionKind: "extensions/v1beta1/Ingress", name: string): pulumi.Output<extensions.v1beta1.Ingress>;
    getResource(groupVersionKind: "extensions/v1beta1/Ingress", namespace: string, name: string): pulumi.Output<extensions.v1beta1.Ingress>;
    getResource(groupVersionKind: "extensions/v1beta1/IngressList", name: string): pulumi.Output<extensions.v1beta1.IngressList>;
    getResource(groupVersionKind: "extensions/v1beta1/IngressList", namespace: string, name: string): pulumi.Output<extensions.v1beta1.IngressList>;
    getResource(groupVersionKind: "extensions/v1beta1/NetworkPolicy", name: string): pulumi.Output<extensions.v1beta1.NetworkPolicy>;
    getResource(groupVersionKind: "extensions/v1beta1/NetworkPolicy", namespace: string, name: string): pulumi.Output<extensions.v1beta1.NetworkPolicy>;
    getResource(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", name: string): pulumi.Output<extensions.v1beta1.NetworkPolicyList>;
    getResource(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", namespace: string, name: string): pulumi.Output<extensions.v1beta1.NetworkPolicyList>;
    getResource(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", name: string): pulumi.Output<extensions.v1beta1.PodSecurityPolicy>;
    getResource(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", namespace: string, name: string): pulumi.Output<extensions.v1beta1.PodSecurityPolicy>;
    getResource(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", name: string): pulumi.Output<extensions.v1beta1.PodSecurityPolicyList>;
    getResource(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", namespace: string, name: string): pulumi.Output<extensions.v1beta1.PodSecurityPolicyList>;
    getResource(groupVersionKind: "extensions/v1beta1/ReplicaSet", name: string): pulumi.Output<extensions.v1beta1.ReplicaSet>;
    getResource(groupVersionKind: "extensions/v1beta1/ReplicaSet", namespace: string, name: string): pulumi.Output<extensions.v1beta1.ReplicaSet>;
    getResource(groupVersionKind: "extensions/v1beta1/ReplicaSetList", name: string): pulumi.Output<extensions.v1beta1.ReplicaSetList>;
    getResource(groupVersionKind: "extensions/v1beta1/ReplicaSetList", namespace: string, name: string): pulumi.Output<extensions.v1beta1.ReplicaSetList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", name: string): pulumi.Output<flowcontrol.v1.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", namespace: string, name: string): pulumi.Output<flowcontrol.v1.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", name: string): pulumi.Output<flowcontrol.v1.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", namespace: string, name: string): pulumi.Output<flowcontrol.v1.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", name: string): pulumi.Output<flowcontrol.v1.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", namespace: string, name: string): pulumi.Output<flowcontrol.v1.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", name: string): pulumi.Output<flowcontrol.v1.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", namespace: string, name: string): pulumi.Output<flowcontrol.v1.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", name: string): pulumi.Output<flowcontrol.v1alpha1.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", namespace: string, name: string): pulumi.Output<flowcontrol.v1alpha1.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", name: string): pulumi.Output<flowcontrol.v1alpha1.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", namespace: string, name: string): pulumi.Output<flowcontrol.v1alpha1.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", name: string): pulumi.Output<flowcontrol.v1alpha1.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", namespace: string, name: string): pulumi.Output<flowcontrol.v1alpha1.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", name: string): pulumi.Output<flowcontrol.v1alpha1.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", namespace: string, name: string): pulumi.Output<flowcontrol.v1alpha1.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", name: string): pulumi.Output<flowcontrol.v1beta1.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta1.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", name: string): pulumi.Output<flowcontrol.v1beta1.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta1.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", name: string): pulumi.Output<flowcontrol.v1beta1.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta1.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", name: string): pulumi.Output<flowcontrol.v1beta1.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta1.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", name: string): pulumi.Output<flowcontrol.v1beta2.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta2.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", name: string): pulumi.Output<flowcontrol.v1beta2.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta2.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", name: string): pulumi.Output<flowcontrol.v1beta2.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta2.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", name: string): pulumi.Output<flowcontrol.v1beta2.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta2.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", name: string): pulumi.Output<flowcontrol.v1beta3.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta3.FlowSchema>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", name: string): pulumi.Output<flowcontrol.v1beta3.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta3.FlowSchemaList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", name: string): pulumi.Output<flowcontrol.v1beta3.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta3.PriorityLevelConfiguration>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", name: string): pulumi.Output<flowcontrol.v1beta3.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", namespace: string, name: string): pulumi.Output<flowcontrol.v1beta3.PriorityLevelConfigurationList>;
    getResource(groupVersionKind: "meta/v1/Status", name: string): pulumi.Output<meta.v1.Status>;
    getResource(groupVersionKind: "meta/v1/Status", namespace: string, name: string): pulumi.Output<meta.v1.Status>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IPAddress", name: string): pulumi.Output<networking.v1.IPAddress>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IPAddress", namespace: string, name: string): pulumi.Output<networking.v1.IPAddress>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IPAddressList", name: string): pulumi.Output<networking.v1.IPAddressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IPAddressList", namespace: string, name: string): pulumi.Output<networking.v1.IPAddressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/Ingress", name: string): pulumi.Output<networking.v1.Ingress>;
    getResource(groupVersionKind: "networking.k8s.io/v1/Ingress", namespace: string, name: string): pulumi.Output<networking.v1.Ingress>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IngressClass", name: string): pulumi.Output<networking.v1.IngressClass>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IngressClass", namespace: string, name: string): pulumi.Output<networking.v1.IngressClass>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IngressClassList", name: string): pulumi.Output<networking.v1.IngressClassList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IngressClassList", namespace: string, name: string): pulumi.Output<networking.v1.IngressClassList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IngressList", name: string): pulumi.Output<networking.v1.IngressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/IngressList", namespace: string, name: string): pulumi.Output<networking.v1.IngressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", name: string): pulumi.Output<networking.v1.NetworkPolicy>;
    getResource(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", namespace: string, name: string): pulumi.Output<networking.v1.NetworkPolicy>;
    getResource(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", name: string): pulumi.Output<networking.v1.NetworkPolicyList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", namespace: string, name: string): pulumi.Output<networking.v1.NetworkPolicyList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", name: string): pulumi.Output<networking.v1.ServiceCIDR>;
    getResource(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", namespace: string, name: string): pulumi.Output<networking.v1.ServiceCIDR>;
    getResource(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", name: string): pulumi.Output<networking.v1.ServiceCIDRList>;
    getResource(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", namespace: string, name: string): pulumi.Output<networking.v1.ServiceCIDRList>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", name: string): pulumi.Output<networking.v1alpha1.ClusterCIDR>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", namespace: string, name: string): pulumi.Output<networking.v1alpha1.ClusterCIDR>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", name: string): pulumi.Output<networking.v1alpha1.ClusterCIDRList>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", namespace: string, name: string): pulumi.Output<networking.v1alpha1.ClusterCIDRList>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", name: string): pulumi.Output<networking.v1alpha1.IPAddress>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", namespace: string, name: string): pulumi.Output<networking.v1alpha1.IPAddress>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", name: string): pulumi.Output<networking.v1alpha1.IPAddressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", namespace: string, name: string): pulumi.Output<networking.v1alpha1.IPAddressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", name: string): pulumi.Output<networking.v1alpha1.ServiceCIDR>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", namespace: string, name: string): pulumi.Output<networking.v1alpha1.ServiceCIDR>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", name: string): pulumi.Output<networking.v1alpha1.ServiceCIDRList>;
    getResource(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", namespace: string, name: string): pulumi.Output<networking.v1alpha1.ServiceCIDRList>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", name: string): pulumi.Output<networking.v1beta1.IPAddress>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", namespace: string, name: string): pulumi.Output<networking.v1beta1.IPAddress>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", name: string): pulumi.Output<networking.v1beta1.IPAddressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", namespace: string, name: string): pulumi.Output<networking.v1beta1.IPAddressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", name: string): pulumi.Output<networking.v1beta1.Ingress>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", namespace: string, name: string): pulumi.Output<networking.v1beta1.Ingress>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", name: string): pulumi.Output<networking.v1beta1.IngressClass>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", namespace: string, name: string): pulumi.Output<networking.v1beta1.IngressClass>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", name: string): pulumi.Output<networking.v1beta1.IngressClassList>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", namespace: string, name: string): pulumi.Output<networking.v1beta1.IngressClassList>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", name: string): pulumi.Output<networking.v1beta1.IngressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", namespace: string, name: string): pulumi.Output<networking.v1beta1.IngressList>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", name: string): pulumi.Output<networking.v1beta1.ServiceCIDR>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", namespace: string, name: string): pulumi.Output<networking.v1beta1.ServiceCIDR>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", name: string): pulumi.Output<networking.v1beta1.ServiceCIDRList>;
    getResource(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", namespace: string, name: string): pulumi.Output<networking.v1beta1.ServiceCIDRList>;
    getResource(groupVersionKind: "node.k8s.io/v1/RuntimeClass", name: string): pulumi.Output<node.v1.RuntimeClass>;
    getResource(groupVersionKind: "node.k8s.io/v1/RuntimeClass", namespace: string, name: string): pulumi.Output<node.v1.RuntimeClass>;
    getResource(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", name: string): pulumi.Output<node.v1.RuntimeClassList>;
    getResource(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", namespace: string, name: string): pulumi.Output<node.v1.RuntimeClassList>;
    getResource(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", name: string): pulumi.Output<node.v1alpha1.RuntimeClass>;
    getResource(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", namespace: string, name: string): pulumi.Output<node.v1alpha1.RuntimeClass>;
    getResource(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", name: string): pulumi.Output<node.v1alpha1.RuntimeClassList>;
    getResource(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", namespace: string, name: string): pulumi.Output<node.v1alpha1.RuntimeClassList>;
    getResource(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", name: string): pulumi.Output<node.v1beta1.RuntimeClass>;
    getResource(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", namespace: string, name: string): pulumi.Output<node.v1beta1.RuntimeClass>;
    getResource(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", name: string): pulumi.Output<node.v1beta1.RuntimeClassList>;
    getResource(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", namespace: string, name: string): pulumi.Output<node.v1beta1.RuntimeClassList>;
    getResource(groupVersionKind: "policy/v1/PodDisruptionBudget", name: string): pulumi.Output<policy.v1.PodDisruptionBudget>;
    getResource(groupVersionKind: "policy/v1/PodDisruptionBudget", namespace: string, name: string): pulumi.Output<policy.v1.PodDisruptionBudget>;
    getResource(groupVersionKind: "policy/v1/PodDisruptionBudgetList", name: string): pulumi.Output<policy.v1.PodDisruptionBudgetList>;
    getResource(groupVersionKind: "policy/v1/PodDisruptionBudgetList", namespace: string, name: string): pulumi.Output<policy.v1.PodDisruptionBudgetList>;
    getResource(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", name: string): pulumi.Output<policy.v1beta1.PodDisruptionBudget>;
    getResource(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", namespace: string, name: string): pulumi.Output<policy.v1beta1.PodDisruptionBudget>;
    getResource(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", name: string): pulumi.Output<policy.v1beta1.PodDisruptionBudgetList>;
    getResource(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", namespace: string, name: string): pulumi.Output<policy.v1beta1.PodDisruptionBudgetList>;
    getResource(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", name: string): pulumi.Output<policy.v1beta1.PodSecurityPolicy>;
    getResource(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", namespace: string, name: string): pulumi.Output<policy.v1beta1.PodSecurityPolicy>;
    getResource(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", name: string): pulumi.Output<policy.v1beta1.PodSecurityPolicyList>;
    getResource(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", namespace: string, name: string): pulumi.Output<policy.v1beta1.PodSecurityPolicyList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", name: string): pulumi.Output<rbac.v1.ClusterRole>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", namespace: string, name: string): pulumi.Output<rbac.v1.ClusterRole>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", name: string): pulumi.Output<rbac.v1.ClusterRoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", namespace: string, name: string): pulumi.Output<rbac.v1.ClusterRoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", name: string): pulumi.Output<rbac.v1.ClusterRoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", namespace: string, name: string): pulumi.Output<rbac.v1.ClusterRoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", name: string): pulumi.Output<rbac.v1.ClusterRoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", namespace: string, name: string): pulumi.Output<rbac.v1.ClusterRoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", name: string): pulumi.Output<rbac.v1.Role>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", namespace: string, name: string): pulumi.Output<rbac.v1.Role>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", name: string): pulumi.Output<rbac.v1.RoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", namespace: string, name: string): pulumi.Output<rbac.v1.RoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", name: string): pulumi.Output<rbac.v1.RoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", namespace: string, name: string): pulumi.Output<rbac.v1.RoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", name: string): pulumi.Output<rbac.v1.RoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", namespace: string, name: string): pulumi.Output<rbac.v1.RoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", name: string): pulumi.Output<rbac.v1alpha1.ClusterRole>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", namespace: string, name: string): pulumi.Output<rbac.v1alpha1.ClusterRole>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", name: string): pulumi.Output<rbac.v1alpha1.ClusterRoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", namespace: string, name: string): pulumi.Output<rbac.v1alpha1.ClusterRoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", name: string): pulumi.Output<rbac.v1alpha1.ClusterRoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", namespace: string, name: string): pulumi.Output<rbac.v1alpha1.ClusterRoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", name: string): pulumi.Output<rbac.v1alpha1.ClusterRoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", namespace: string, name: string): pulumi.Output<rbac.v1alpha1.ClusterRoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", name: string): pulumi.Output<rbac.v1alpha1.Role>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", namespace: string, name: string): pulumi.Output<rbac.v1alpha1.Role>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", name: string): pulumi.Output<rbac.v1alpha1.RoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", namespace: string, name: string): pulumi.Output<rbac.v1alpha1.RoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", name: string): pulumi.Output<rbac.v1alpha1.RoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", namespace: string, name: string): pulumi.Output<rbac.v1alpha1.RoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", name: string): pulumi.Output<rbac.v1alpha1.RoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", namespace: string, name: string): pulumi.Output<rbac.v1alpha1.RoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", name: string): pulumi.Output<rbac.v1beta1.ClusterRole>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", namespace: string, name: string): pulumi.Output<rbac.v1beta1.ClusterRole>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", name: string): pulumi.Output<rbac.v1beta1.ClusterRoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", namespace: string, name: string): pulumi.Output<rbac.v1beta1.ClusterRoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", name: string): pulumi.Output<rbac.v1beta1.ClusterRoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", namespace: string, name: string): pulumi.Output<rbac.v1beta1.ClusterRoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", name: string): pulumi.Output<rbac.v1beta1.ClusterRoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", namespace: string, name: string): pulumi.Output<rbac.v1beta1.ClusterRoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", name: string): pulumi.Output<rbac.v1beta1.Role>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", namespace: string, name: string): pulumi.Output<rbac.v1beta1.Role>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", name: string): pulumi.Output<rbac.v1beta1.RoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", namespace: string, name: string): pulumi.Output<rbac.v1beta1.RoleBinding>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", name: string): pulumi.Output<rbac.v1beta1.RoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", namespace: string, name: string): pulumi.Output<rbac.v1beta1.RoleBindingList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", name: string): pulumi.Output<rbac.v1beta1.RoleList>;
    getResource(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", namespace: string, name: string): pulumi.Output<rbac.v1beta1.RoleList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", name: string): pulumi.Output<resource.v1alpha1.PodScheduling>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", namespace: string, name: string): pulumi.Output<resource.v1alpha1.PodScheduling>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", name: string): pulumi.Output<resource.v1alpha1.PodSchedulingList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", namespace: string, name: string): pulumi.Output<resource.v1alpha1.PodSchedulingList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", name: string): pulumi.Output<resource.v1alpha1.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", namespace: string, name: string): pulumi.Output<resource.v1alpha1.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", name: string): pulumi.Output<resource.v1alpha1.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", namespace: string, name: string): pulumi.Output<resource.v1alpha1.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", name: string): pulumi.Output<resource.v1alpha1.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", namespace: string, name: string): pulumi.Output<resource.v1alpha1.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", name: string): pulumi.Output<resource.v1alpha1.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", namespace: string, name: string): pulumi.Output<resource.v1alpha1.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", name: string): pulumi.Output<resource.v1alpha1.ResourceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", namespace: string, name: string): pulumi.Output<resource.v1alpha1.ResourceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", name: string): pulumi.Output<resource.v1alpha1.ResourceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", namespace: string, name: string): pulumi.Output<resource.v1alpha1.ResourceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", name: string): pulumi.Output<resource.v1alpha2.PodSchedulingContext>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", namespace: string, name: string): pulumi.Output<resource.v1alpha2.PodSchedulingContext>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", name: string): pulumi.Output<resource.v1alpha2.PodSchedulingContextList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", namespace: string, name: string): pulumi.Output<resource.v1alpha2.PodSchedulingContextList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", name: string): pulumi.Output<resource.v1alpha2.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", name: string): pulumi.Output<resource.v1alpha2.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", name: string): pulumi.Output<resource.v1alpha2.ResourceClaimParameters>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClaimParameters>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", name: string): pulumi.Output<resource.v1alpha2.ResourceClaimParametersList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClaimParametersList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", name: string): pulumi.Output<resource.v1alpha2.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", name: string): pulumi.Output<resource.v1alpha2.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", name: string): pulumi.Output<resource.v1alpha2.ResourceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", name: string): pulumi.Output<resource.v1alpha2.ResourceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", name: string): pulumi.Output<resource.v1alpha2.ResourceClassParameters>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClassParameters>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", name: string): pulumi.Output<resource.v1alpha2.ResourceClassParametersList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceClassParametersList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", name: string): pulumi.Output<resource.v1alpha2.ResourceSlice>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceSlice>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", name: string): pulumi.Output<resource.v1alpha2.ResourceSliceList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", namespace: string, name: string): pulumi.Output<resource.v1alpha2.ResourceSliceList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", name: string): pulumi.Output<resource.v1alpha3.DeviceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", namespace: string, name: string): pulumi.Output<resource.v1alpha3.DeviceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", name: string): pulumi.Output<resource.v1alpha3.DeviceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", namespace: string, name: string): pulumi.Output<resource.v1alpha3.DeviceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", name: string): pulumi.Output<resource.v1alpha3.DeviceTaintRule>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", namespace: string, name: string): pulumi.Output<resource.v1alpha3.DeviceTaintRule>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", name: string): pulumi.Output<resource.v1alpha3.DeviceTaintRuleList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", namespace: string, name: string): pulumi.Output<resource.v1alpha3.DeviceTaintRuleList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", name: string): pulumi.Output<resource.v1alpha3.PodSchedulingContext>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", namespace: string, name: string): pulumi.Output<resource.v1alpha3.PodSchedulingContext>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", name: string): pulumi.Output<resource.v1alpha3.PodSchedulingContextList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", namespace: string, name: string): pulumi.Output<resource.v1alpha3.PodSchedulingContextList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", name: string): pulumi.Output<resource.v1alpha3.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", namespace: string, name: string): pulumi.Output<resource.v1alpha3.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", name: string): pulumi.Output<resource.v1alpha3.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", namespace: string, name: string): pulumi.Output<resource.v1alpha3.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", name: string): pulumi.Output<resource.v1alpha3.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", namespace: string, name: string): pulumi.Output<resource.v1alpha3.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", name: string): pulumi.Output<resource.v1alpha3.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", namespace: string, name: string): pulumi.Output<resource.v1alpha3.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", name: string): pulumi.Output<resource.v1alpha3.ResourceSlice>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", namespace: string, name: string): pulumi.Output<resource.v1alpha3.ResourceSlice>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", name: string): pulumi.Output<resource.v1alpha3.ResourceSliceList>;
    getResource(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", namespace: string, name: string): pulumi.Output<resource.v1alpha3.ResourceSliceList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", name: string): pulumi.Output<resource.v1beta1.DeviceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", namespace: string, name: string): pulumi.Output<resource.v1beta1.DeviceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", name: string): pulumi.Output<resource.v1beta1.DeviceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", namespace: string, name: string): pulumi.Output<resource.v1beta1.DeviceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", name: string): pulumi.Output<resource.v1beta1.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", namespace: string, name: string): pulumi.Output<resource.v1beta1.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", name: string): pulumi.Output<resource.v1beta1.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", namespace: string, name: string): pulumi.Output<resource.v1beta1.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", name: string): pulumi.Output<resource.v1beta1.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", namespace: string, name: string): pulumi.Output<resource.v1beta1.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", name: string): pulumi.Output<resource.v1beta1.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", namespace: string, name: string): pulumi.Output<resource.v1beta1.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", name: string): pulumi.Output<resource.v1beta1.ResourceSlice>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", namespace: string, name: string): pulumi.Output<resource.v1beta1.ResourceSlice>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", name: string): pulumi.Output<resource.v1beta1.ResourceSliceList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", namespace: string, name: string): pulumi.Output<resource.v1beta1.ResourceSliceList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", name: string): pulumi.Output<resource.v1beta2.DeviceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", namespace: string, name: string): pulumi.Output<resource.v1beta2.DeviceClass>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", name: string): pulumi.Output<resource.v1beta2.DeviceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", namespace: string, name: string): pulumi.Output<resource.v1beta2.DeviceClassList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", name: string): pulumi.Output<resource.v1beta2.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", namespace: string, name: string): pulumi.Output<resource.v1beta2.ResourceClaim>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", name: string): pulumi.Output<resource.v1beta2.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", namespace: string, name: string): pulumi.Output<resource.v1beta2.ResourceClaimList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", name: string): pulumi.Output<resource.v1beta2.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", namespace: string, name: string): pulumi.Output<resource.v1beta2.ResourceClaimTemplate>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", name: string): pulumi.Output<resource.v1beta2.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", namespace: string, name: string): pulumi.Output<resource.v1beta2.ResourceClaimTemplateList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", name: string): pulumi.Output<resource.v1beta2.ResourceSlice>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", namespace: string, name: string): pulumi.Output<resource.v1beta2.ResourceSlice>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", name: string): pulumi.Output<resource.v1beta2.ResourceSliceList>;
    getResource(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", namespace: string, name: string): pulumi.Output<resource.v1beta2.ResourceSliceList>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", name: string): pulumi.Output<scheduling.v1.PriorityClass>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", namespace: string, name: string): pulumi.Output<scheduling.v1.PriorityClass>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", name: string): pulumi.Output<scheduling.v1.PriorityClassList>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", namespace: string, name: string): pulumi.Output<scheduling.v1.PriorityClassList>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", name: string): pulumi.Output<scheduling.v1alpha1.PriorityClass>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", namespace: string, name: string): pulumi.Output<scheduling.v1alpha1.PriorityClass>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", name: string): pulumi.Output<scheduling.v1alpha1.PriorityClassList>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", namespace: string, name: string): pulumi.Output<scheduling.v1alpha1.PriorityClassList>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", name: string): pulumi.Output<scheduling.v1beta1.PriorityClass>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", namespace: string, name: string): pulumi.Output<scheduling.v1beta1.PriorityClass>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", name: string): pulumi.Output<scheduling.v1beta1.PriorityClassList>;
    getResource(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", namespace: string, name: string): pulumi.Output<scheduling.v1beta1.PriorityClassList>;
    getResource(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", name: string): pulumi.Output<settings.v1alpha1.PodPreset>;
    getResource(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", namespace: string, name: string): pulumi.Output<settings.v1alpha1.PodPreset>;
    getResource(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", name: string): pulumi.Output<settings.v1alpha1.PodPresetList>;
    getResource(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", namespace: string, name: string): pulumi.Output<settings.v1alpha1.PodPresetList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSIDriver", name: string): pulumi.Output<storage.v1.CSIDriver>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSIDriver", namespace: string, name: string): pulumi.Output<storage.v1.CSIDriver>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", name: string): pulumi.Output<storage.v1.CSIDriverList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", namespace: string, name: string): pulumi.Output<storage.v1.CSIDriverList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSINode", name: string): pulumi.Output<storage.v1.CSINode>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSINode", namespace: string, name: string): pulumi.Output<storage.v1.CSINode>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSINodeList", name: string): pulumi.Output<storage.v1.CSINodeList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSINodeList", namespace: string, name: string): pulumi.Output<storage.v1.CSINodeList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", name: string): pulumi.Output<storage.v1.CSIStorageCapacity>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", namespace: string, name: string): pulumi.Output<storage.v1.CSIStorageCapacity>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", name: string): pulumi.Output<storage.v1.CSIStorageCapacityList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", namespace: string, name: string): pulumi.Output<storage.v1.CSIStorageCapacityList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string): pulumi.Output<storage.v1.StorageClass>;
    getResource(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string): pulumi.Output<storage.v1.StorageClass>;
    getResource(groupVersionKind: "storage.k8s.io/v1/StorageClassList", name: string): pulumi.Output<storage.v1.StorageClassList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/StorageClassList", namespace: string, name: string): pulumi.Output<storage.v1.StorageClassList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", name: string): pulumi.Output<storage.v1.VolumeAttachment>;
    getResource(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", namespace: string, name: string): pulumi.Output<storage.v1.VolumeAttachment>;
    getResource(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", name: string): pulumi.Output<storage.v1.VolumeAttachmentList>;
    getResource(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", namespace: string, name: string): pulumi.Output<storage.v1.VolumeAttachmentList>;
    getResource(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", name: string): pulumi.Output<storage.v1alpha1.VolumeAttachment>;
    getResource(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", namespace: string, name: string): pulumi.Output<storage.v1alpha1.VolumeAttachment>;
    getResource(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", name: string): pulumi.Output<storage.v1alpha1.VolumeAttachmentList>;
    getResource(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", namespace: string, name: string): pulumi.Output<storage.v1alpha1.VolumeAttachmentList>;
    getResource(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", name: string): pulumi.Output<storage.v1alpha1.VolumeAttributesClass>;
    getResource(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", namespace: string, name: string): pulumi.Output<storage.v1alpha1.VolumeAttributesClass>;
    getResource(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", name: string): pulumi.Output<storage.v1alpha1.VolumeAttributesClassList>;
    getResource(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", namespace: string, name: string): pulumi.Output<storage.v1alpha1.VolumeAttributesClassList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", name: string): pulumi.Output<storage.v1beta1.CSIDriver>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", namespace: string, name: string): pulumi.Output<storage.v1beta1.CSIDriver>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", name: string): pulumi.Output<storage.v1beta1.CSIDriverList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", namespace: string, name: string): pulumi.Output<storage.v1beta1.CSIDriverList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", name: string): pulumi.Output<storage.v1beta1.CSINode>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", namespace: string, name: string): pulumi.Output<storage.v1beta1.CSINode>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", name: string): pulumi.Output<storage.v1beta1.CSINodeList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", namespace: string, name: string): pulumi.Output<storage.v1beta1.CSINodeList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", name: string): pulumi.Output<storage.v1beta1.CSIStorageCapacity>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", namespace: string, name: string): pulumi.Output<storage.v1beta1.CSIStorageCapacity>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", name: string): pulumi.Output<storage.v1beta1.CSIStorageCapacityList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", namespace: string, name: string): pulumi.Output<storage.v1beta1.CSIStorageCapacityList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string): pulumi.Output<storage.v1beta1.StorageClass>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string): pulumi.Output<storage.v1beta1.StorageClass>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", name: string): pulumi.Output<storage.v1beta1.StorageClassList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", namespace: string, name: string): pulumi.Output<storage.v1beta1.StorageClassList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", name: string): pulumi.Output<storage.v1beta1.VolumeAttachment>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", namespace: string, name: string): pulumi.Output<storage.v1beta1.VolumeAttachment>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", name: string): pulumi.Output<storage.v1beta1.VolumeAttachmentList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", namespace: string, name: string): pulumi.Output<storage.v1beta1.VolumeAttachmentList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", name: string): pulumi.Output<storage.v1beta1.VolumeAttributesClass>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", namespace: string, name: string): pulumi.Output<storage.v1beta1.VolumeAttributesClass>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", name: string): pulumi.Output<storage.v1beta1.VolumeAttributesClassList>;
    getResource(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", namespace: string, name: string): pulumi.Output<storage.v1beta1.VolumeAttributesClassList>;
    getResource(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", name: string): pulumi.Output<storagemigration.v1alpha1.StorageVersionMigration>;
    getResource(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", namespace: string, name: string): pulumi.Output<storagemigration.v1alpha1.StorageVersionMigration>;
    getResource(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", name: string): pulumi.Output<storagemigration.v1alpha1.StorageVersionMigrationList>;
    getResource(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", namespace: string, name: string): pulumi.Output<storagemigration.v1alpha1.StorageVersionMigrationList>;
    /**
     * getResourceProperty returns a single property of a resource defined by a built-in Kubernetes group/version/kind and name.
     *
     * For example:
     *     getResourceProperty("v1/Service", "nginx", "spec")
     */
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", name: string, property: "kind"): pulumi.Output<"MutatingWebhookConfiguration">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"MutatingWebhookConfiguration">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", name: string, property: "webhooks"): pulumi.Output<outputs.admissionregistration.v1.MutatingWebhook[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfiguration", namespace: string, name: string, property: "webhooks"): pulumi.Output<outputs.admissionregistration.v1.MutatingWebhook[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1.MutatingWebhookConfiguration[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1.MutatingWebhookConfiguration[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", name: string, property: "kind"): pulumi.Output<"MutatingWebhookConfigurationList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"MutatingWebhookConfigurationList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/MutatingWebhookConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicy">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicy">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicySpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicySpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", name: string, property: "status"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicyStatus>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "status"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicyStatus>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBinding">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBinding">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicyBindingSpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicyBindingSpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicyBinding[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicyBinding[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBindingList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBindingList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicy[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1.ValidatingAdmissionPolicy[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", name: string, property: "kind"): pulumi.Output<"ValidatingWebhookConfiguration">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingWebhookConfiguration">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", name: string, property: "webhooks"): pulumi.Output<outputs.admissionregistration.v1.ValidatingWebhook[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfiguration", namespace: string, name: string, property: "webhooks"): pulumi.Output<outputs.admissionregistration.v1.ValidatingWebhook[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1.ValidatingWebhookConfiguration[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1.ValidatingWebhookConfiguration[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", name: string, property: "kind"): pulumi.Output<"ValidatingWebhookConfigurationList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingWebhookConfigurationList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1/ValidatingWebhookConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", name: string, property: "kind"): pulumi.Output<"MutatingAdmissionPolicy">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", namespace: string, name: string, property: "kind"): pulumi.Output<"MutatingAdmissionPolicy">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1alpha1.MutatingAdmissionPolicySpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicy", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1alpha1.MutatingAdmissionPolicySpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", name: string, property: "kind"): pulumi.Output<"MutatingAdmissionPolicyBinding">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"MutatingAdmissionPolicyBinding">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1alpha1.MutatingAdmissionPolicyBindingSpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBinding", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1alpha1.MutatingAdmissionPolicyBindingSpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1alpha1.MutatingAdmissionPolicyBinding[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1alpha1.MutatingAdmissionPolicyBinding[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", name: string, property: "kind"): pulumi.Output<"MutatingAdmissionPolicyBindingList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"MutatingAdmissionPolicyBindingList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1alpha1.MutatingAdmissionPolicy[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1alpha1.MutatingAdmissionPolicy[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", name: string, property: "kind"): pulumi.Output<"MutatingAdmissionPolicyList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", namespace: string, name: string, property: "kind"): pulumi.Output<"MutatingAdmissionPolicyList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/MutatingAdmissionPolicyList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicy">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicy">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicySpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicySpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", name: string, property: "status"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicyStatus>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "status"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicyStatus>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBinding">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBinding">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingSpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingSpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBindingList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBindingList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicy[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1alpha1.ValidatingAdmissionPolicy[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1alpha1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", name: string, property: "kind"): pulumi.Output<"MutatingWebhookConfiguration">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"MutatingWebhookConfiguration">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", name: string, property: "webhooks"): pulumi.Output<outputs.admissionregistration.v1beta1.MutatingWebhook[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfiguration", namespace: string, name: string, property: "webhooks"): pulumi.Output<outputs.admissionregistration.v1beta1.MutatingWebhook[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1beta1.MutatingWebhookConfiguration[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1beta1.MutatingWebhookConfiguration[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", name: string, property: "kind"): pulumi.Output<"MutatingWebhookConfigurationList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"MutatingWebhookConfigurationList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/MutatingWebhookConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicy">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicy">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicySpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicySpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", name: string, property: "status"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicyStatus>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicy", namespace: string, name: string, property: "status"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicyStatus>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBinding">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBinding">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingSpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBinding", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingSpec>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBindingList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyBindingList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicy[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingAdmissionPolicy[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingAdmissionPolicyList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingAdmissionPolicyList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", name: string, property: "kind"): pulumi.Output<"ValidatingWebhookConfiguration">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingWebhookConfiguration">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", name: string, property: "webhooks"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingWebhook[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfiguration", namespace: string, name: string, property: "webhooks"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingWebhook[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"admissionregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingWebhookConfiguration[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.admissionregistration.v1beta1.ValidatingWebhookConfiguration[]>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", name: string, property: "kind"): pulumi.Output<"ValidatingWebhookConfigurationList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"ValidatingWebhookConfigurationList">;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "admissionregistration.k8s.io/v1beta1/ValidatingWebhookConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", name: string, property: "apiVersion"): pulumi.Output<"apiextensions.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apiextensions.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", name: string, property: "kind"): pulumi.Output<"CustomResourceDefinition">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", namespace: string, name: string, property: "kind"): pulumi.Output<"CustomResourceDefinition">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", name: string, property: "spec"): pulumi.Output<outputs.apiextensions.v1.CustomResourceDefinitionSpec>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apiextensions.v1.CustomResourceDefinitionSpec>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", name: string, property: "status"): pulumi.Output<outputs.apiextensions.v1.CustomResourceDefinitionStatus>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinition", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apiextensions.v1.CustomResourceDefinitionStatus>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", name: string, property: "apiVersion"): pulumi.Output<"apiextensions.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apiextensions.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", name: string, property: "items"): pulumi.Output<outputs.apiextensions.v1.CustomResourceDefinition[]>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apiextensions.v1.CustomResourceDefinition[]>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", name: string, property: "kind"): pulumi.Output<"CustomResourceDefinitionList">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", namespace: string, name: string, property: "kind"): pulumi.Output<"CustomResourceDefinitionList">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1/CustomResourceDefinitionList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", name: string, property: "apiVersion"): pulumi.Output<"apiextensions.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apiextensions.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", name: string, property: "kind"): pulumi.Output<"CustomResourceDefinition">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", namespace: string, name: string, property: "kind"): pulumi.Output<"CustomResourceDefinition">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", name: string, property: "spec"): pulumi.Output<outputs.apiextensions.v1beta1.CustomResourceDefinitionSpec>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apiextensions.v1beta1.CustomResourceDefinitionSpec>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", name: string, property: "status"): pulumi.Output<outputs.apiextensions.v1beta1.CustomResourceDefinitionStatus>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinition", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apiextensions.v1beta1.CustomResourceDefinitionStatus>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", name: string, property: "apiVersion"): pulumi.Output<"apiextensions.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apiextensions.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", name: string, property: "items"): pulumi.Output<outputs.apiextensions.v1beta1.CustomResourceDefinition[]>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apiextensions.v1beta1.CustomResourceDefinition[]>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", name: string, property: "kind"): pulumi.Output<"CustomResourceDefinitionList">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", namespace: string, name: string, property: "kind"): pulumi.Output<"CustomResourceDefinitionList">;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apiextensions.k8s.io/v1beta1/CustomResourceDefinitionList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", name: string, property: "apiVersion"): pulumi.Output<"apiregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apiregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", name: string, property: "kind"): pulumi.Output<"APIService">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", namespace: string, name: string, property: "kind"): pulumi.Output<"APIService">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", name: string, property: "spec"): pulumi.Output<outputs.apiregistration.v1.APIServiceSpec>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apiregistration.v1.APIServiceSpec>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", name: string, property: "status"): pulumi.Output<outputs.apiregistration.v1.APIServiceStatus>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIService", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apiregistration.v1.APIServiceStatus>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", name: string, property: "apiVersion"): pulumi.Output<"apiregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apiregistration.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", name: string, property: "items"): pulumi.Output<outputs.apiregistration.v1.APIService[]>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apiregistration.v1.APIService[]>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", name: string, property: "kind"): pulumi.Output<"APIServiceList">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", namespace: string, name: string, property: "kind"): pulumi.Output<"APIServiceList">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1/APIServiceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", name: string, property: "apiVersion"): pulumi.Output<"apiregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apiregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", name: string, property: "kind"): pulumi.Output<"APIService">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", namespace: string, name: string, property: "kind"): pulumi.Output<"APIService">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", name: string, property: "spec"): pulumi.Output<outputs.apiregistration.v1beta1.APIServiceSpec>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apiregistration.v1beta1.APIServiceSpec>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", name: string, property: "status"): pulumi.Output<outputs.apiregistration.v1beta1.APIServiceStatus>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIService", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apiregistration.v1beta1.APIServiceStatus>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", name: string, property: "apiVersion"): pulumi.Output<"apiregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apiregistration.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", name: string, property: "items"): pulumi.Output<outputs.apiregistration.v1beta1.APIService[]>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apiregistration.v1beta1.APIService[]>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", name: string, property: "kind"): pulumi.Output<"APIServiceList">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", namespace: string, name: string, property: "kind"): pulumi.Output<"APIServiceList">;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apiregistration.k8s.io/v1beta1/APIServiceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", name: string, property: "data"): pulumi.Output<any>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", namespace: string, name: string, property: "data"): pulumi.Output<any>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", name: string, property: "kind"): pulumi.Output<"ControllerRevision">;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", namespace: string, name: string, property: "kind"): pulumi.Output<"ControllerRevision">;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", name: string, property: "revision"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevision", namespace: string, name: string, property: "revision"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevisionList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevisionList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevisionList", name: string, property: "items"): pulumi.Output<outputs.apps.v1.ControllerRevision[]>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevisionList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1.ControllerRevision[]>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevisionList", name: string, property: "kind"): pulumi.Output<"ControllerRevisionList">;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevisionList", namespace: string, name: string, property: "kind"): pulumi.Output<"ControllerRevisionList">;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevisionList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/ControllerRevisionList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", name: string, property: "kind"): pulumi.Output<"DaemonSet">;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", namespace: string, name: string, property: "kind"): pulumi.Output<"DaemonSet">;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", name: string, property: "spec"): pulumi.Output<outputs.apps.v1.DaemonSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1.DaemonSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", name: string, property: "status"): pulumi.Output<outputs.apps.v1.DaemonSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1.DaemonSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSetList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSetList", name: string, property: "items"): pulumi.Output<outputs.apps.v1.DaemonSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1.DaemonSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSetList", name: string, property: "kind"): pulumi.Output<"DaemonSetList">;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"DaemonSetList">;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/DaemonSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", name: string, property: "kind"): pulumi.Output<"Deployment">;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", namespace: string, name: string, property: "kind"): pulumi.Output<"Deployment">;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", name: string, property: "spec"): pulumi.Output<outputs.apps.v1.DeploymentSpec>;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1.DeploymentSpec>;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", name: string, property: "status"): pulumi.Output<outputs.apps.v1.DeploymentStatus>;
    getResourceProperty(groupVersionKind: "apps/v1/Deployment", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1.DeploymentStatus>;
    getResourceProperty(groupVersionKind: "apps/v1/DeploymentList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/DeploymentList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/DeploymentList", name: string, property: "items"): pulumi.Output<outputs.apps.v1.Deployment[]>;
    getResourceProperty(groupVersionKind: "apps/v1/DeploymentList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1.Deployment[]>;
    getResourceProperty(groupVersionKind: "apps/v1/DeploymentList", name: string, property: "kind"): pulumi.Output<"DeploymentList">;
    getResourceProperty(groupVersionKind: "apps/v1/DeploymentList", namespace: string, name: string, property: "kind"): pulumi.Output<"DeploymentList">;
    getResourceProperty(groupVersionKind: "apps/v1/DeploymentList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/DeploymentList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", name: string, property: "kind"): pulumi.Output<"ReplicaSet">;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", namespace: string, name: string, property: "kind"): pulumi.Output<"ReplicaSet">;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", name: string, property: "spec"): pulumi.Output<outputs.apps.v1.ReplicaSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1.ReplicaSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", name: string, property: "status"): pulumi.Output<outputs.apps.v1.ReplicaSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1.ReplicaSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSetList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSetList", name: string, property: "items"): pulumi.Output<outputs.apps.v1.ReplicaSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1.ReplicaSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSetList", name: string, property: "kind"): pulumi.Output<"ReplicaSetList">;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"ReplicaSetList">;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/ReplicaSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", name: string, property: "kind"): pulumi.Output<"StatefulSet">;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", namespace: string, name: string, property: "kind"): pulumi.Output<"StatefulSet">;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", name: string, property: "spec"): pulumi.Output<outputs.apps.v1.StatefulSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1.StatefulSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", name: string, property: "status"): pulumi.Output<outputs.apps.v1.StatefulSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1.StatefulSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSetList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1">;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSetList", name: string, property: "items"): pulumi.Output<outputs.apps.v1.StatefulSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1.StatefulSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSetList", name: string, property: "kind"): pulumi.Output<"StatefulSetList">;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"StatefulSetList">;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1/StatefulSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", name: string, property: "data"): pulumi.Output<any>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", namespace: string, name: string, property: "data"): pulumi.Output<any>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", name: string, property: "kind"): pulumi.Output<"ControllerRevision">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", namespace: string, name: string, property: "kind"): pulumi.Output<"ControllerRevision">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", name: string, property: "revision"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevision", namespace: string, name: string, property: "revision"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevisionList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevisionList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevisionList", name: string, property: "items"): pulumi.Output<outputs.apps.v1beta1.ControllerRevision[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevisionList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1beta1.ControllerRevision[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevisionList", name: string, property: "kind"): pulumi.Output<"ControllerRevisionList">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevisionList", namespace: string, name: string, property: "kind"): pulumi.Output<"ControllerRevisionList">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevisionList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/ControllerRevisionList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", name: string, property: "kind"): pulumi.Output<"Deployment">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", namespace: string, name: string, property: "kind"): pulumi.Output<"Deployment">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta1.DeploymentSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta1.DeploymentSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", name: string, property: "status"): pulumi.Output<outputs.apps.v1beta1.DeploymentStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/Deployment", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1beta1.DeploymentStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/DeploymentList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/DeploymentList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/DeploymentList", name: string, property: "items"): pulumi.Output<outputs.apps.v1beta1.Deployment[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/DeploymentList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1beta1.Deployment[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/DeploymentList", name: string, property: "kind"): pulumi.Output<"DeploymentList">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/DeploymentList", namespace: string, name: string, property: "kind"): pulumi.Output<"DeploymentList">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/DeploymentList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/DeploymentList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", name: string, property: "kind"): pulumi.Output<"StatefulSet">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", namespace: string, name: string, property: "kind"): pulumi.Output<"StatefulSet">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta1.StatefulSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta1.StatefulSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", name: string, property: "status"): pulumi.Output<outputs.apps.v1beta1.StatefulSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1beta1.StatefulSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSetList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta1">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSetList", name: string, property: "items"): pulumi.Output<outputs.apps.v1beta1.StatefulSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1beta1.StatefulSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSetList", name: string, property: "kind"): pulumi.Output<"StatefulSetList">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"StatefulSetList">;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta1/StatefulSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", name: string, property: "data"): pulumi.Output<any>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", namespace: string, name: string, property: "data"): pulumi.Output<any>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", name: string, property: "kind"): pulumi.Output<"ControllerRevision">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", namespace: string, name: string, property: "kind"): pulumi.Output<"ControllerRevision">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", name: string, property: "revision"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevision", namespace: string, name: string, property: "revision"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevisionList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevisionList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevisionList", name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.ControllerRevision[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevisionList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.ControllerRevision[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevisionList", name: string, property: "kind"): pulumi.Output<"ControllerRevisionList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevisionList", namespace: string, name: string, property: "kind"): pulumi.Output<"ControllerRevisionList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevisionList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ControllerRevisionList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", name: string, property: "kind"): pulumi.Output<"DaemonSet">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", namespace: string, name: string, property: "kind"): pulumi.Output<"DaemonSet">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta2.DaemonSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta2.DaemonSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", name: string, property: "status"): pulumi.Output<outputs.apps.v1beta2.DaemonSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1beta2.DaemonSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSetList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSetList", name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.DaemonSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.DaemonSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSetList", name: string, property: "kind"): pulumi.Output<"DaemonSetList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"DaemonSetList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DaemonSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", name: string, property: "kind"): pulumi.Output<"Deployment">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", namespace: string, name: string, property: "kind"): pulumi.Output<"Deployment">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta2.DeploymentSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta2.DeploymentSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", name: string, property: "status"): pulumi.Output<outputs.apps.v1beta2.DeploymentStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/Deployment", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1beta2.DeploymentStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DeploymentList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DeploymentList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DeploymentList", name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.Deployment[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DeploymentList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.Deployment[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DeploymentList", name: string, property: "kind"): pulumi.Output<"DeploymentList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DeploymentList", namespace: string, name: string, property: "kind"): pulumi.Output<"DeploymentList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DeploymentList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/DeploymentList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", name: string, property: "kind"): pulumi.Output<"ReplicaSet">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", namespace: string, name: string, property: "kind"): pulumi.Output<"ReplicaSet">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta2.ReplicaSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta2.ReplicaSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", name: string, property: "status"): pulumi.Output<outputs.apps.v1beta2.ReplicaSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1beta2.ReplicaSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSetList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSetList", name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.ReplicaSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.ReplicaSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSetList", name: string, property: "kind"): pulumi.Output<"ReplicaSetList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"ReplicaSetList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/ReplicaSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", name: string, property: "kind"): pulumi.Output<"StatefulSet">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", namespace: string, name: string, property: "kind"): pulumi.Output<"StatefulSet">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta2.StatefulSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.apps.v1beta2.StatefulSetSpec>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", name: string, property: "status"): pulumi.Output<outputs.apps.v1beta2.StatefulSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.apps.v1beta2.StatefulSetStatus>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSetList", name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"apps/v1beta2">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSetList", name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.StatefulSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.apps.v1beta2.StatefulSet[]>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSetList", name: string, property: "kind"): pulumi.Output<"StatefulSetList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"StatefulSetList">;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "apps/v1beta2/StatefulSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", name: string, property: "apiVersion"): pulumi.Output<"auditregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"auditregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", name: string, property: "kind"): pulumi.Output<"AuditSink">;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", namespace: string, name: string, property: "kind"): pulumi.Output<"AuditSink">;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", name: string, property: "spec"): pulumi.Output<outputs.auditregistration.v1alpha1.AuditSinkSpec>;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSink", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.auditregistration.v1alpha1.AuditSinkSpec>;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", name: string, property: "apiVersion"): pulumi.Output<"auditregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"auditregistration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", name: string, property: "items"): pulumi.Output<outputs.auditregistration.v1alpha1.AuditSink[]>;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.auditregistration.v1alpha1.AuditSink[]>;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", name: string, property: "kind"): pulumi.Output<"AuditSinkList">;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", namespace: string, name: string, property: "kind"): pulumi.Output<"AuditSinkList">;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "auditregistration.k8s.io/v1alpha1/AuditSinkList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v1">;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v1">;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscaler">;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", namespace: string, name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscaler">;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", name: string, property: "spec"): pulumi.Output<outputs.autoscaling.v1.HorizontalPodAutoscalerSpec>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.autoscaling.v1.HorizontalPodAutoscalerSpec>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", name: string, property: "status"): pulumi.Output<outputs.autoscaling.v1.HorizontalPodAutoscalerStatus>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscaler", namespace: string, name: string, property: "status"): pulumi.Output<outputs.autoscaling.v1.HorizontalPodAutoscalerStatus>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v1">;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v1">;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", name: string, property: "items"): pulumi.Output<outputs.autoscaling.v1.HorizontalPodAutoscaler[]>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.autoscaling.v1.HorizontalPodAutoscaler[]>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscalerList">;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", namespace: string, name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscalerList">;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v1/HorizontalPodAutoscalerList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2">;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2">;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscaler">;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", namespace: string, name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscaler">;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", name: string, property: "spec"): pulumi.Output<outputs.autoscaling.v2.HorizontalPodAutoscalerSpec>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.autoscaling.v2.HorizontalPodAutoscalerSpec>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", name: string, property: "status"): pulumi.Output<outputs.autoscaling.v2.HorizontalPodAutoscalerStatus>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscaler", namespace: string, name: string, property: "status"): pulumi.Output<outputs.autoscaling.v2.HorizontalPodAutoscalerStatus>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2">;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2">;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", name: string, property: "items"): pulumi.Output<outputs.autoscaling.v2.HorizontalPodAutoscaler[]>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.autoscaling.v2.HorizontalPodAutoscaler[]>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscalerList">;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", namespace: string, name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscalerList">;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2/HorizontalPodAutoscalerList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2beta1">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2beta1">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscaler">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", namespace: string, name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscaler">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", name: string, property: "spec"): pulumi.Output<outputs.autoscaling.v2beta1.HorizontalPodAutoscalerSpec>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.autoscaling.v2beta1.HorizontalPodAutoscalerSpec>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", name: string, property: "status"): pulumi.Output<outputs.autoscaling.v2beta1.HorizontalPodAutoscalerStatus>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscaler", namespace: string, name: string, property: "status"): pulumi.Output<outputs.autoscaling.v2beta1.HorizontalPodAutoscalerStatus>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2beta1">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2beta1">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", name: string, property: "items"): pulumi.Output<outputs.autoscaling.v2beta1.HorizontalPodAutoscaler[]>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.autoscaling.v2beta1.HorizontalPodAutoscaler[]>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscalerList">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", namespace: string, name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscalerList">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta1/HorizontalPodAutoscalerList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2beta2">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2beta2">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscaler">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", namespace: string, name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscaler">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", name: string, property: "spec"): pulumi.Output<outputs.autoscaling.v2beta2.HorizontalPodAutoscalerSpec>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.autoscaling.v2beta2.HorizontalPodAutoscalerSpec>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", name: string, property: "status"): pulumi.Output<outputs.autoscaling.v2beta2.HorizontalPodAutoscalerStatus>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscaler", namespace: string, name: string, property: "status"): pulumi.Output<outputs.autoscaling.v2beta2.HorizontalPodAutoscalerStatus>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2beta2">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"autoscaling/v2beta2">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", name: string, property: "items"): pulumi.Output<outputs.autoscaling.v2beta2.HorizontalPodAutoscaler[]>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.autoscaling.v2beta2.HorizontalPodAutoscaler[]>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscalerList">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", namespace: string, name: string, property: "kind"): pulumi.Output<"HorizontalPodAutoscalerList">;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "autoscaling/v2beta2/HorizontalPodAutoscalerList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", name: string, property: "apiVersion"): pulumi.Output<"batch/v1">;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"batch/v1">;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", name: string, property: "kind"): pulumi.Output<"CronJob">;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", namespace: string, name: string, property: "kind"): pulumi.Output<"CronJob">;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", name: string, property: "spec"): pulumi.Output<outputs.batch.v1.CronJobSpec>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.batch.v1.CronJobSpec>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", name: string, property: "status"): pulumi.Output<outputs.batch.v1.CronJobStatus>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJob", namespace: string, name: string, property: "status"): pulumi.Output<outputs.batch.v1.CronJobStatus>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJobList", name: string, property: "apiVersion"): pulumi.Output<"batch/v1">;
    getResourceProperty(groupVersionKind: "batch/v1/CronJobList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"batch/v1">;
    getResourceProperty(groupVersionKind: "batch/v1/CronJobList", name: string, property: "items"): pulumi.Output<outputs.batch.v1.CronJob[]>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJobList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.batch.v1.CronJob[]>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJobList", name: string, property: "kind"): pulumi.Output<"CronJobList">;
    getResourceProperty(groupVersionKind: "batch/v1/CronJobList", namespace: string, name: string, property: "kind"): pulumi.Output<"CronJobList">;
    getResourceProperty(groupVersionKind: "batch/v1/CronJobList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "batch/v1/CronJobList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "batch/v1/Job", name: string, property: "apiVersion"): pulumi.Output<"batch/v1">;
    getResourceProperty(groupVersionKind: "batch/v1/Job", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"batch/v1">;
    getResourceProperty(groupVersionKind: "batch/v1/Job", name: string, property: "kind"): pulumi.Output<"Job">;
    getResourceProperty(groupVersionKind: "batch/v1/Job", namespace: string, name: string, property: "kind"): pulumi.Output<"Job">;
    getResourceProperty(groupVersionKind: "batch/v1/Job", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "batch/v1/Job", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "batch/v1/Job", name: string, property: "spec"): pulumi.Output<outputs.batch.v1.JobSpec>;
    getResourceProperty(groupVersionKind: "batch/v1/Job", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.batch.v1.JobSpec>;
    getResourceProperty(groupVersionKind: "batch/v1/Job", name: string, property: "status"): pulumi.Output<outputs.batch.v1.JobStatus>;
    getResourceProperty(groupVersionKind: "batch/v1/Job", namespace: string, name: string, property: "status"): pulumi.Output<outputs.batch.v1.JobStatus>;
    getResourceProperty(groupVersionKind: "batch/v1/JobList", name: string, property: "apiVersion"): pulumi.Output<"batch/v1">;
    getResourceProperty(groupVersionKind: "batch/v1/JobList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"batch/v1">;
    getResourceProperty(groupVersionKind: "batch/v1/JobList", name: string, property: "items"): pulumi.Output<outputs.batch.v1.Job[]>;
    getResourceProperty(groupVersionKind: "batch/v1/JobList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.batch.v1.Job[]>;
    getResourceProperty(groupVersionKind: "batch/v1/JobList", name: string, property: "kind"): pulumi.Output<"JobList">;
    getResourceProperty(groupVersionKind: "batch/v1/JobList", namespace: string, name: string, property: "kind"): pulumi.Output<"JobList">;
    getResourceProperty(groupVersionKind: "batch/v1/JobList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "batch/v1/JobList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", name: string, property: "apiVersion"): pulumi.Output<"batch/v1beta1">;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"batch/v1beta1">;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", name: string, property: "kind"): pulumi.Output<"CronJob">;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", namespace: string, name: string, property: "kind"): pulumi.Output<"CronJob">;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", name: string, property: "spec"): pulumi.Output<outputs.batch.v1beta1.CronJobSpec>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.batch.v1beta1.CronJobSpec>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", name: string, property: "status"): pulumi.Output<outputs.batch.v1beta1.CronJobStatus>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJob", namespace: string, name: string, property: "status"): pulumi.Output<outputs.batch.v1beta1.CronJobStatus>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJobList", name: string, property: "apiVersion"): pulumi.Output<"batch/v1beta1">;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJobList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"batch/v1beta1">;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJobList", name: string, property: "items"): pulumi.Output<outputs.batch.v1beta1.CronJob[]>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJobList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.batch.v1beta1.CronJob[]>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJobList", name: string, property: "kind"): pulumi.Output<"CronJobList">;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJobList", namespace: string, name: string, property: "kind"): pulumi.Output<"CronJobList">;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJobList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "batch/v1beta1/CronJobList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", name: string, property: "apiVersion"): pulumi.Output<"batch/v2alpha1">;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"batch/v2alpha1">;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", name: string, property: "kind"): pulumi.Output<"CronJob">;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", namespace: string, name: string, property: "kind"): pulumi.Output<"CronJob">;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", name: string, property: "spec"): pulumi.Output<outputs.batch.v2alpha1.CronJobSpec>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.batch.v2alpha1.CronJobSpec>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", name: string, property: "status"): pulumi.Output<outputs.batch.v2alpha1.CronJobStatus>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJob", namespace: string, name: string, property: "status"): pulumi.Output<outputs.batch.v2alpha1.CronJobStatus>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJobList", name: string, property: "apiVersion"): pulumi.Output<"batch/v2alpha1">;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJobList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"batch/v2alpha1">;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJobList", name: string, property: "items"): pulumi.Output<outputs.batch.v2alpha1.CronJob[]>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJobList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.batch.v2alpha1.CronJob[]>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJobList", name: string, property: "kind"): pulumi.Output<"CronJobList">;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJobList", namespace: string, name: string, property: "kind"): pulumi.Output<"CronJobList">;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJobList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "batch/v2alpha1/CronJobList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", name: string, property: "kind"): pulumi.Output<"CertificateSigningRequest">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", namespace: string, name: string, property: "kind"): pulumi.Output<"CertificateSigningRequest">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", name: string, property: "spec"): pulumi.Output<outputs.certificates.v1.CertificateSigningRequestSpec>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.certificates.v1.CertificateSigningRequestSpec>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", name: string, property: "status"): pulumi.Output<outputs.certificates.v1.CertificateSigningRequestStatus>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequest", namespace: string, name: string, property: "status"): pulumi.Output<outputs.certificates.v1.CertificateSigningRequestStatus>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", name: string, property: "items"): pulumi.Output<outputs.certificates.v1.CertificateSigningRequest[]>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.certificates.v1.CertificateSigningRequest[]>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", name: string, property: "kind"): pulumi.Output<"CertificateSigningRequestList">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", namespace: string, name: string, property: "kind"): pulumi.Output<"CertificateSigningRequestList">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1/CertificateSigningRequestList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", name: string, property: "kind"): pulumi.Output<"ClusterTrustBundle">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterTrustBundle">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", name: string, property: "spec"): pulumi.Output<outputs.certificates.v1alpha1.ClusterTrustBundleSpec>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundle", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.certificates.v1alpha1.ClusterTrustBundleSpec>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", name: string, property: "items"): pulumi.Output<outputs.certificates.v1alpha1.ClusterTrustBundle[]>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.certificates.v1alpha1.ClusterTrustBundle[]>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", name: string, property: "kind"): pulumi.Output<"ClusterTrustBundleList">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterTrustBundleList">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1alpha1/ClusterTrustBundleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", name: string, property: "kind"): pulumi.Output<"CertificateSigningRequest">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", namespace: string, name: string, property: "kind"): pulumi.Output<"CertificateSigningRequest">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", name: string, property: "spec"): pulumi.Output<outputs.certificates.v1beta1.CertificateSigningRequestSpec>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.certificates.v1beta1.CertificateSigningRequestSpec>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", name: string, property: "status"): pulumi.Output<outputs.certificates.v1beta1.CertificateSigningRequestStatus>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequest", namespace: string, name: string, property: "status"): pulumi.Output<outputs.certificates.v1beta1.CertificateSigningRequestStatus>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", name: string, property: "items"): pulumi.Output<outputs.certificates.v1beta1.CertificateSigningRequest[]>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.certificates.v1beta1.CertificateSigningRequest[]>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", name: string, property: "kind"): pulumi.Output<"CertificateSigningRequestList">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", namespace: string, name: string, property: "kind"): pulumi.Output<"CertificateSigningRequestList">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/CertificateSigningRequestList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", name: string, property: "kind"): pulumi.Output<"ClusterTrustBundle">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterTrustBundle">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", name: string, property: "spec"): pulumi.Output<outputs.certificates.v1beta1.ClusterTrustBundleSpec>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundle", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.certificates.v1beta1.ClusterTrustBundleSpec>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"certificates.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", name: string, property: "items"): pulumi.Output<outputs.certificates.v1beta1.ClusterTrustBundle[]>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.certificates.v1beta1.ClusterTrustBundle[]>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", name: string, property: "kind"): pulumi.Output<"ClusterTrustBundleList">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterTrustBundleList">;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "certificates.k8s.io/v1beta1/ClusterTrustBundleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/Lease", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/Lease", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/Lease", name: string, property: "kind"): pulumi.Output<"Lease">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/Lease", namespace: string, name: string, property: "kind"): pulumi.Output<"Lease">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/Lease", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/Lease", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/Lease", name: string, property: "spec"): pulumi.Output<outputs.coordination.v1.LeaseSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/Lease", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.coordination.v1.LeaseSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/LeaseList", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/LeaseList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/LeaseList", name: string, property: "items"): pulumi.Output<outputs.coordination.v1.Lease[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/LeaseList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.coordination.v1.Lease[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/LeaseList", name: string, property: "kind"): pulumi.Output<"LeaseList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/LeaseList", namespace: string, name: string, property: "kind"): pulumi.Output<"LeaseList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/LeaseList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1/LeaseList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", name: string, property: "kind"): pulumi.Output<"LeaseCandidate">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", namespace: string, name: string, property: "kind"): pulumi.Output<"LeaseCandidate">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", name: string, property: "spec"): pulumi.Output<outputs.coordination.v1alpha1.LeaseCandidateSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidate", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.coordination.v1alpha1.LeaseCandidateSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", name: string, property: "items"): pulumi.Output<outputs.coordination.v1alpha1.LeaseCandidate[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.coordination.v1alpha1.LeaseCandidate[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", name: string, property: "kind"): pulumi.Output<"LeaseCandidateList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", namespace: string, name: string, property: "kind"): pulumi.Output<"LeaseCandidateList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha1/LeaseCandidateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", name: string, property: "kind"): pulumi.Output<"LeaseCandidate">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", namespace: string, name: string, property: "kind"): pulumi.Output<"LeaseCandidate">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", name: string, property: "spec"): pulumi.Output<outputs.coordination.v1alpha2.LeaseCandidateSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidate", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.coordination.v1alpha2.LeaseCandidateSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", name: string, property: "items"): pulumi.Output<outputs.coordination.v1alpha2.LeaseCandidate[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.coordination.v1alpha2.LeaseCandidate[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", name: string, property: "kind"): pulumi.Output<"LeaseCandidateList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", namespace: string, name: string, property: "kind"): pulumi.Output<"LeaseCandidateList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1alpha2/LeaseCandidateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", name: string, property: "kind"): pulumi.Output<"Lease">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", namespace: string, name: string, property: "kind"): pulumi.Output<"Lease">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", name: string, property: "spec"): pulumi.Output<outputs.coordination.v1beta1.LeaseSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/Lease", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.coordination.v1beta1.LeaseSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", name: string, property: "kind"): pulumi.Output<"LeaseCandidate">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", namespace: string, name: string, property: "kind"): pulumi.Output<"LeaseCandidate">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", name: string, property: "spec"): pulumi.Output<outputs.coordination.v1beta1.LeaseCandidateSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidate", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.coordination.v1beta1.LeaseCandidateSpec>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", name: string, property: "items"): pulumi.Output<outputs.coordination.v1beta1.LeaseCandidate[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.coordination.v1beta1.LeaseCandidate[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", name: string, property: "kind"): pulumi.Output<"LeaseCandidateList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", namespace: string, name: string, property: "kind"): pulumi.Output<"LeaseCandidateList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseCandidateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"coordination.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", name: string, property: "items"): pulumi.Output<outputs.coordination.v1beta1.Lease[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.coordination.v1beta1.Lease[]>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", name: string, property: "kind"): pulumi.Output<"LeaseList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", namespace: string, name: string, property: "kind"): pulumi.Output<"LeaseList">;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "coordination.k8s.io/v1beta1/LeaseList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/Binding", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Binding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Binding", name: string, property: "kind"): pulumi.Output<"Binding">;
    getResourceProperty(groupVersionKind: "v1/Binding", namespace: string, name: string, property: "kind"): pulumi.Output<"Binding">;
    getResourceProperty(groupVersionKind: "v1/Binding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Binding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Binding", name: string, property: "target"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "v1/Binding", namespace: string, name: string, property: "target"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", name: string, property: "binaryData"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", namespace: string, name: string, property: "binaryData"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", name: string, property: "data"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", namespace: string, name: string, property: "data"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", name: string, property: "immutable"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", namespace: string, name: string, property: "immutable"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", name: string, property: "kind"): pulumi.Output<"ConfigMap">;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", namespace: string, name: string, property: "kind"): pulumi.Output<"ConfigMap">;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/ConfigMap", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/ConfigMapList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ConfigMapList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ConfigMapList", name: string, property: "items"): pulumi.Output<outputs.core.v1.ConfigMap[]>;
    getResourceProperty(groupVersionKind: "v1/ConfigMapList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.ConfigMap[]>;
    getResourceProperty(groupVersionKind: "v1/ConfigMapList", name: string, property: "kind"): pulumi.Output<"ConfigMapList">;
    getResourceProperty(groupVersionKind: "v1/ConfigMapList", namespace: string, name: string, property: "kind"): pulumi.Output<"ConfigMapList">;
    getResourceProperty(groupVersionKind: "v1/ConfigMapList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/ConfigMapList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/Endpoints", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Endpoints", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Endpoints", name: string, property: "kind"): pulumi.Output<"Endpoints">;
    getResourceProperty(groupVersionKind: "v1/Endpoints", namespace: string, name: string, property: "kind"): pulumi.Output<"Endpoints">;
    getResourceProperty(groupVersionKind: "v1/Endpoints", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Endpoints", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Endpoints", name: string, property: "subsets"): pulumi.Output<outputs.core.v1.EndpointSubset[]>;
    getResourceProperty(groupVersionKind: "v1/Endpoints", namespace: string, name: string, property: "subsets"): pulumi.Output<outputs.core.v1.EndpointSubset[]>;
    getResourceProperty(groupVersionKind: "v1/EndpointsList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/EndpointsList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/EndpointsList", name: string, property: "items"): pulumi.Output<outputs.core.v1.Endpoints[]>;
    getResourceProperty(groupVersionKind: "v1/EndpointsList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.Endpoints[]>;
    getResourceProperty(groupVersionKind: "v1/EndpointsList", name: string, property: "kind"): pulumi.Output<"EndpointsList">;
    getResourceProperty(groupVersionKind: "v1/EndpointsList", namespace: string, name: string, property: "kind"): pulumi.Output<"EndpointsList">;
    getResourceProperty(groupVersionKind: "v1/EndpointsList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/EndpointsList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "action"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "action"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "count"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "count"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "eventTime"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "eventTime"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "firstTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "firstTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "involvedObject"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "involvedObject"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "kind"): pulumi.Output<"Event">;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "kind"): pulumi.Output<"Event">;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "lastTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "lastTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "message"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "message"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "reason"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "reason"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "related"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "related"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "reportingComponent"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "reportingComponent"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "reportingInstance"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "reportingInstance"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "series"): pulumi.Output<outputs.core.v1.EventSeries>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "series"): pulumi.Output<outputs.core.v1.EventSeries>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "source"): pulumi.Output<outputs.core.v1.EventSource>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "source"): pulumi.Output<outputs.core.v1.EventSource>;
    getResourceProperty(groupVersionKind: "v1/Event", name: string, property: "type"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Event", namespace: string, name: string, property: "type"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/EventList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/EventList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/EventList", name: string, property: "items"): pulumi.Output<outputs.core.v1.Event[]>;
    getResourceProperty(groupVersionKind: "v1/EventList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.Event[]>;
    getResourceProperty(groupVersionKind: "v1/EventList", name: string, property: "kind"): pulumi.Output<"EventList">;
    getResourceProperty(groupVersionKind: "v1/EventList", namespace: string, name: string, property: "kind"): pulumi.Output<"EventList">;
    getResourceProperty(groupVersionKind: "v1/EventList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/EventList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/LimitRange", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/LimitRange", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/LimitRange", name: string, property: "kind"): pulumi.Output<"LimitRange">;
    getResourceProperty(groupVersionKind: "v1/LimitRange", namespace: string, name: string, property: "kind"): pulumi.Output<"LimitRange">;
    getResourceProperty(groupVersionKind: "v1/LimitRange", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/LimitRange", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/LimitRange", name: string, property: "spec"): pulumi.Output<outputs.core.v1.LimitRangeSpec>;
    getResourceProperty(groupVersionKind: "v1/LimitRange", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.LimitRangeSpec>;
    getResourceProperty(groupVersionKind: "v1/LimitRangeList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/LimitRangeList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/LimitRangeList", name: string, property: "items"): pulumi.Output<outputs.core.v1.LimitRange[]>;
    getResourceProperty(groupVersionKind: "v1/LimitRangeList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.LimitRange[]>;
    getResourceProperty(groupVersionKind: "v1/LimitRangeList", name: string, property: "kind"): pulumi.Output<"LimitRangeList">;
    getResourceProperty(groupVersionKind: "v1/LimitRangeList", namespace: string, name: string, property: "kind"): pulumi.Output<"LimitRangeList">;
    getResourceProperty(groupVersionKind: "v1/LimitRangeList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/LimitRangeList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/Namespace", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Namespace", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Namespace", name: string, property: "kind"): pulumi.Output<"Namespace">;
    getResourceProperty(groupVersionKind: "v1/Namespace", namespace: string, name: string, property: "kind"): pulumi.Output<"Namespace">;
    getResourceProperty(groupVersionKind: "v1/Namespace", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Namespace", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Namespace", name: string, property: "spec"): pulumi.Output<outputs.core.v1.NamespaceSpec>;
    getResourceProperty(groupVersionKind: "v1/Namespace", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.NamespaceSpec>;
    getResourceProperty(groupVersionKind: "v1/Namespace", name: string, property: "status"): pulumi.Output<outputs.core.v1.NamespaceStatus>;
    getResourceProperty(groupVersionKind: "v1/Namespace", namespace: string, name: string, property: "status"): pulumi.Output<outputs.core.v1.NamespaceStatus>;
    getResourceProperty(groupVersionKind: "v1/NamespaceList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/NamespaceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/NamespaceList", name: string, property: "items"): pulumi.Output<outputs.core.v1.Namespace[]>;
    getResourceProperty(groupVersionKind: "v1/NamespaceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.Namespace[]>;
    getResourceProperty(groupVersionKind: "v1/NamespaceList", name: string, property: "kind"): pulumi.Output<"NamespaceList">;
    getResourceProperty(groupVersionKind: "v1/NamespaceList", namespace: string, name: string, property: "kind"): pulumi.Output<"NamespaceList">;
    getResourceProperty(groupVersionKind: "v1/NamespaceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/NamespaceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/Node", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Node", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Node", name: string, property: "kind"): pulumi.Output<"Node">;
    getResourceProperty(groupVersionKind: "v1/Node", namespace: string, name: string, property: "kind"): pulumi.Output<"Node">;
    getResourceProperty(groupVersionKind: "v1/Node", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Node", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Node", name: string, property: "spec"): pulumi.Output<outputs.core.v1.NodeSpec>;
    getResourceProperty(groupVersionKind: "v1/Node", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.NodeSpec>;
    getResourceProperty(groupVersionKind: "v1/Node", name: string, property: "status"): pulumi.Output<outputs.core.v1.NodeStatus>;
    getResourceProperty(groupVersionKind: "v1/Node", namespace: string, name: string, property: "status"): pulumi.Output<outputs.core.v1.NodeStatus>;
    getResourceProperty(groupVersionKind: "v1/NodeList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/NodeList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/NodeList", name: string, property: "items"): pulumi.Output<outputs.core.v1.Node[]>;
    getResourceProperty(groupVersionKind: "v1/NodeList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.Node[]>;
    getResourceProperty(groupVersionKind: "v1/NodeList", name: string, property: "kind"): pulumi.Output<"NodeList">;
    getResourceProperty(groupVersionKind: "v1/NodeList", namespace: string, name: string, property: "kind"): pulumi.Output<"NodeList">;
    getResourceProperty(groupVersionKind: "v1/NodeList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/NodeList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", name: string, property: "kind"): pulumi.Output<"PersistentVolume">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", namespace: string, name: string, property: "kind"): pulumi.Output<"PersistentVolume">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", name: string, property: "spec"): pulumi.Output<outputs.core.v1.PersistentVolumeSpec>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.PersistentVolumeSpec>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", name: string, property: "status"): pulumi.Output<outputs.core.v1.PersistentVolumeStatus>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolume", namespace: string, name: string, property: "status"): pulumi.Output<outputs.core.v1.PersistentVolumeStatus>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", name: string, property: "kind"): pulumi.Output<"PersistentVolumeClaim">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", namespace: string, name: string, property: "kind"): pulumi.Output<"PersistentVolumeClaim">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", name: string, property: "spec"): pulumi.Output<outputs.core.v1.PersistentVolumeClaimSpec>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.PersistentVolumeClaimSpec>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", name: string, property: "status"): pulumi.Output<outputs.core.v1.PersistentVolumeClaimStatus>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaim", namespace: string, name: string, property: "status"): pulumi.Output<outputs.core.v1.PersistentVolumeClaimStatus>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaimList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaimList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaimList", name: string, property: "items"): pulumi.Output<outputs.core.v1.PersistentVolumeClaim[]>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaimList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.PersistentVolumeClaim[]>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaimList", name: string, property: "kind"): pulumi.Output<"PersistentVolumeClaimList">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaimList", namespace: string, name: string, property: "kind"): pulumi.Output<"PersistentVolumeClaimList">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaimList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeClaimList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeList", name: string, property: "items"): pulumi.Output<outputs.core.v1.PersistentVolume[]>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.PersistentVolume[]>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeList", name: string, property: "kind"): pulumi.Output<"PersistentVolumeList">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeList", namespace: string, name: string, property: "kind"): pulumi.Output<"PersistentVolumeList">;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/PersistentVolumeList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/Pod", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Pod", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Pod", name: string, property: "kind"): pulumi.Output<"Pod">;
    getResourceProperty(groupVersionKind: "v1/Pod", namespace: string, name: string, property: "kind"): pulumi.Output<"Pod">;
    getResourceProperty(groupVersionKind: "v1/Pod", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Pod", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Pod", name: string, property: "spec"): pulumi.Output<outputs.core.v1.PodSpec>;
    getResourceProperty(groupVersionKind: "v1/Pod", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.PodSpec>;
    getResourceProperty(groupVersionKind: "v1/Pod", name: string, property: "status"): pulumi.Output<outputs.core.v1.PodStatus>;
    getResourceProperty(groupVersionKind: "v1/Pod", namespace: string, name: string, property: "status"): pulumi.Output<outputs.core.v1.PodStatus>;
    getResourceProperty(groupVersionKind: "v1/PodList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PodList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PodList", name: string, property: "items"): pulumi.Output<outputs.core.v1.Pod[]>;
    getResourceProperty(groupVersionKind: "v1/PodList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.Pod[]>;
    getResourceProperty(groupVersionKind: "v1/PodList", name: string, property: "kind"): pulumi.Output<"PodList">;
    getResourceProperty(groupVersionKind: "v1/PodList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodList">;
    getResourceProperty(groupVersionKind: "v1/PodList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/PodList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/PodTemplate", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PodTemplate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PodTemplate", name: string, property: "kind"): pulumi.Output<"PodTemplate">;
    getResourceProperty(groupVersionKind: "v1/PodTemplate", namespace: string, name: string, property: "kind"): pulumi.Output<"PodTemplate">;
    getResourceProperty(groupVersionKind: "v1/PodTemplate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/PodTemplate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/PodTemplate", name: string, property: "template"): pulumi.Output<outputs.core.v1.PodTemplateSpec>;
    getResourceProperty(groupVersionKind: "v1/PodTemplate", namespace: string, name: string, property: "template"): pulumi.Output<outputs.core.v1.PodTemplateSpec>;
    getResourceProperty(groupVersionKind: "v1/PodTemplateList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PodTemplateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/PodTemplateList", name: string, property: "items"): pulumi.Output<outputs.core.v1.PodTemplate[]>;
    getResourceProperty(groupVersionKind: "v1/PodTemplateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.PodTemplate[]>;
    getResourceProperty(groupVersionKind: "v1/PodTemplateList", name: string, property: "kind"): pulumi.Output<"PodTemplateList">;
    getResourceProperty(groupVersionKind: "v1/PodTemplateList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodTemplateList">;
    getResourceProperty(groupVersionKind: "v1/PodTemplateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/PodTemplateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", name: string, property: "kind"): pulumi.Output<"ReplicationController">;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", namespace: string, name: string, property: "kind"): pulumi.Output<"ReplicationController">;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", name: string, property: "spec"): pulumi.Output<outputs.core.v1.ReplicationControllerSpec>;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.ReplicationControllerSpec>;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", name: string, property: "status"): pulumi.Output<outputs.core.v1.ReplicationControllerStatus>;
    getResourceProperty(groupVersionKind: "v1/ReplicationController", namespace: string, name: string, property: "status"): pulumi.Output<outputs.core.v1.ReplicationControllerStatus>;
    getResourceProperty(groupVersionKind: "v1/ReplicationControllerList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ReplicationControllerList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ReplicationControllerList", name: string, property: "items"): pulumi.Output<outputs.core.v1.ReplicationController[]>;
    getResourceProperty(groupVersionKind: "v1/ReplicationControllerList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.ReplicationController[]>;
    getResourceProperty(groupVersionKind: "v1/ReplicationControllerList", name: string, property: "kind"): pulumi.Output<"ReplicationControllerList">;
    getResourceProperty(groupVersionKind: "v1/ReplicationControllerList", namespace: string, name: string, property: "kind"): pulumi.Output<"ReplicationControllerList">;
    getResourceProperty(groupVersionKind: "v1/ReplicationControllerList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/ReplicationControllerList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", name: string, property: "kind"): pulumi.Output<"ResourceQuota">;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceQuota">;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", name: string, property: "spec"): pulumi.Output<outputs.core.v1.ResourceQuotaSpec>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.ResourceQuotaSpec>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", name: string, property: "status"): pulumi.Output<outputs.core.v1.ResourceQuotaStatus>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuota", namespace: string, name: string, property: "status"): pulumi.Output<outputs.core.v1.ResourceQuotaStatus>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuotaList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ResourceQuotaList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ResourceQuotaList", name: string, property: "items"): pulumi.Output<outputs.core.v1.ResourceQuota[]>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuotaList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.ResourceQuota[]>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuotaList", name: string, property: "kind"): pulumi.Output<"ResourceQuotaList">;
    getResourceProperty(groupVersionKind: "v1/ResourceQuotaList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceQuotaList">;
    getResourceProperty(groupVersionKind: "v1/ResourceQuotaList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/ResourceQuotaList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/Secret", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Secret", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Secret", name: string, property: "data"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "v1/Secret", namespace: string, name: string, property: "data"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "v1/Secret", name: string, property: "immutable"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "v1/Secret", namespace: string, name: string, property: "immutable"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "v1/Secret", name: string, property: "kind"): pulumi.Output<"Secret">;
    getResourceProperty(groupVersionKind: "v1/Secret", namespace: string, name: string, property: "kind"): pulumi.Output<"Secret">;
    getResourceProperty(groupVersionKind: "v1/Secret", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Secret", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Secret", name: string, property: "stringData"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "v1/Secret", namespace: string, name: string, property: "stringData"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "v1/Secret", name: string, property: "type"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/Secret", namespace: string, name: string, property: "type"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "v1/SecretList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/SecretList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/SecretList", name: string, property: "items"): pulumi.Output<outputs.core.v1.Secret[]>;
    getResourceProperty(groupVersionKind: "v1/SecretList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.Secret[]>;
    getResourceProperty(groupVersionKind: "v1/SecretList", name: string, property: "kind"): pulumi.Output<"SecretList">;
    getResourceProperty(groupVersionKind: "v1/SecretList", namespace: string, name: string, property: "kind"): pulumi.Output<"SecretList">;
    getResourceProperty(groupVersionKind: "v1/SecretList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/SecretList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/Service", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Service", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/Service", name: string, property: "kind"): pulumi.Output<"Service">;
    getResourceProperty(groupVersionKind: "v1/Service", namespace: string, name: string, property: "kind"): pulumi.Output<"Service">;
    getResourceProperty(groupVersionKind: "v1/Service", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Service", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/Service", name: string, property: "spec"): pulumi.Output<outputs.core.v1.ServiceSpec>;
    getResourceProperty(groupVersionKind: "v1/Service", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.core.v1.ServiceSpec>;
    getResourceProperty(groupVersionKind: "v1/Service", name: string, property: "status"): pulumi.Output<outputs.core.v1.ServiceStatus>;
    getResourceProperty(groupVersionKind: "v1/Service", namespace: string, name: string, property: "status"): pulumi.Output<outputs.core.v1.ServiceStatus>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", name: string, property: "automountServiceAccountToken"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", namespace: string, name: string, property: "automountServiceAccountToken"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", name: string, property: "imagePullSecrets"): pulumi.Output<outputs.core.v1.LocalObjectReference[]>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", namespace: string, name: string, property: "imagePullSecrets"): pulumi.Output<outputs.core.v1.LocalObjectReference[]>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", name: string, property: "kind"): pulumi.Output<"ServiceAccount">;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceAccount">;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", name: string, property: "secrets"): pulumi.Output<outputs.core.v1.ObjectReference[]>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccount", namespace: string, name: string, property: "secrets"): pulumi.Output<outputs.core.v1.ObjectReference[]>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccountList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ServiceAccountList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ServiceAccountList", name: string, property: "items"): pulumi.Output<outputs.core.v1.ServiceAccount[]>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccountList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.ServiceAccount[]>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccountList", name: string, property: "kind"): pulumi.Output<"ServiceAccountList">;
    getResourceProperty(groupVersionKind: "v1/ServiceAccountList", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceAccountList">;
    getResourceProperty(groupVersionKind: "v1/ServiceAccountList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/ServiceAccountList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/ServiceList", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ServiceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "v1/ServiceList", name: string, property: "items"): pulumi.Output<outputs.core.v1.Service[]>;
    getResourceProperty(groupVersionKind: "v1/ServiceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.core.v1.Service[]>;
    getResourceProperty(groupVersionKind: "v1/ServiceList", name: string, property: "kind"): pulumi.Output<"ServiceList">;
    getResourceProperty(groupVersionKind: "v1/ServiceList", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceList">;
    getResourceProperty(groupVersionKind: "v1/ServiceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "v1/ServiceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", name: string, property: "addressType"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", namespace: string, name: string, property: "addressType"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", name: string, property: "apiVersion"): pulumi.Output<"discovery.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"discovery.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", name: string, property: "endpoints"): pulumi.Output<outputs.discovery.v1.Endpoint[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", namespace: string, name: string, property: "endpoints"): pulumi.Output<outputs.discovery.v1.Endpoint[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", name: string, property: "kind"): pulumi.Output<"EndpointSlice">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", namespace: string, name: string, property: "kind"): pulumi.Output<"EndpointSlice">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", name: string, property: "ports"): pulumi.Output<outputs.discovery.v1.EndpointPort[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSlice", namespace: string, name: string, property: "ports"): pulumi.Output<outputs.discovery.v1.EndpointPort[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", name: string, property: "apiVersion"): pulumi.Output<"discovery.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"discovery.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", name: string, property: "items"): pulumi.Output<outputs.discovery.v1.EndpointSlice[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.discovery.v1.EndpointSlice[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", name: string, property: "kind"): pulumi.Output<"EndpointSliceList">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", namespace: string, name: string, property: "kind"): pulumi.Output<"EndpointSliceList">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1/EndpointSliceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", name: string, property: "addressType"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", namespace: string, name: string, property: "addressType"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", name: string, property: "apiVersion"): pulumi.Output<"discovery.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"discovery.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", name: string, property: "endpoints"): pulumi.Output<outputs.discovery.v1beta1.Endpoint[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", namespace: string, name: string, property: "endpoints"): pulumi.Output<outputs.discovery.v1beta1.Endpoint[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", name: string, property: "kind"): pulumi.Output<"EndpointSlice">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", namespace: string, name: string, property: "kind"): pulumi.Output<"EndpointSlice">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", name: string, property: "ports"): pulumi.Output<outputs.discovery.v1beta1.EndpointPort[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSlice", namespace: string, name: string, property: "ports"): pulumi.Output<outputs.discovery.v1beta1.EndpointPort[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", name: string, property: "apiVersion"): pulumi.Output<"discovery.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"discovery.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", name: string, property: "items"): pulumi.Output<outputs.discovery.v1beta1.EndpointSlice[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.discovery.v1beta1.EndpointSlice[]>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", name: string, property: "kind"): pulumi.Output<"EndpointSliceList">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", namespace: string, name: string, property: "kind"): pulumi.Output<"EndpointSliceList">;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "discovery.k8s.io/v1beta1/EndpointSliceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "action"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "action"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "apiVersion"): pulumi.Output<"events.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"events.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "deprecatedCount"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "deprecatedCount"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "deprecatedFirstTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "deprecatedFirstTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "deprecatedLastTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "deprecatedLastTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "deprecatedSource"): pulumi.Output<outputs.core.v1.EventSource>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "deprecatedSource"): pulumi.Output<outputs.core.v1.EventSource>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "eventTime"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "eventTime"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "kind"): pulumi.Output<"Event">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "kind"): pulumi.Output<"Event">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "note"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "note"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "reason"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "reason"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "regarding"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "regarding"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "related"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "related"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "reportingController"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "reportingController"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "reportingInstance"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "reportingInstance"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "series"): pulumi.Output<outputs.events.v1.EventSeries>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "series"): pulumi.Output<outputs.events.v1.EventSeries>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", name: string, property: "type"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/Event", namespace: string, name: string, property: "type"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/EventList", name: string, property: "apiVersion"): pulumi.Output<"events.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/EventList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"events.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/EventList", name: string, property: "items"): pulumi.Output<outputs.events.v1.Event[]>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/EventList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.events.v1.Event[]>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/EventList", name: string, property: "kind"): pulumi.Output<"EventList">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/EventList", namespace: string, name: string, property: "kind"): pulumi.Output<"EventList">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/EventList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1/EventList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "action"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "action"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "apiVersion"): pulumi.Output<"events.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"events.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "deprecatedCount"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "deprecatedCount"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "deprecatedFirstTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "deprecatedFirstTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "deprecatedLastTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "deprecatedLastTimestamp"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "deprecatedSource"): pulumi.Output<outputs.core.v1.EventSource>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "deprecatedSource"): pulumi.Output<outputs.core.v1.EventSource>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "eventTime"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "eventTime"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "kind"): pulumi.Output<"Event">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "kind"): pulumi.Output<"Event">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "note"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "note"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "reason"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "reason"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "regarding"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "regarding"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "related"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "related"): pulumi.Output<outputs.core.v1.ObjectReference>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "reportingController"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "reportingController"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "reportingInstance"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "reportingInstance"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "series"): pulumi.Output<outputs.events.v1beta1.EventSeries>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "series"): pulumi.Output<outputs.events.v1beta1.EventSeries>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", name: string, property: "type"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/Event", namespace: string, name: string, property: "type"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/EventList", name: string, property: "apiVersion"): pulumi.Output<"events.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/EventList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"events.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/EventList", name: string, property: "items"): pulumi.Output<outputs.events.v1beta1.Event[]>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/EventList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.events.v1beta1.Event[]>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/EventList", name: string, property: "kind"): pulumi.Output<"EventList">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/EventList", namespace: string, name: string, property: "kind"): pulumi.Output<"EventList">;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/EventList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "events.k8s.io/v1beta1/EventList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", name: string, property: "kind"): pulumi.Output<"DaemonSet">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", namespace: string, name: string, property: "kind"): pulumi.Output<"DaemonSet">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.DaemonSetSpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.DaemonSetSpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", name: string, property: "status"): pulumi.Output<outputs.extensions.v1beta1.DaemonSetStatus>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.extensions.v1beta1.DaemonSetStatus>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSetList", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSetList", name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.DaemonSet[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.DaemonSet[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSetList", name: string, property: "kind"): pulumi.Output<"DaemonSetList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"DaemonSetList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DaemonSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", name: string, property: "kind"): pulumi.Output<"Deployment">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", namespace: string, name: string, property: "kind"): pulumi.Output<"Deployment">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.DeploymentSpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.DeploymentSpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", name: string, property: "status"): pulumi.Output<outputs.extensions.v1beta1.DeploymentStatus>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Deployment", namespace: string, name: string, property: "status"): pulumi.Output<outputs.extensions.v1beta1.DeploymentStatus>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DeploymentList", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DeploymentList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DeploymentList", name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.Deployment[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DeploymentList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.Deployment[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DeploymentList", name: string, property: "kind"): pulumi.Output<"DeploymentList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DeploymentList", namespace: string, name: string, property: "kind"): pulumi.Output<"DeploymentList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DeploymentList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/DeploymentList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", name: string, property: "kind"): pulumi.Output<"Ingress">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", namespace: string, name: string, property: "kind"): pulumi.Output<"Ingress">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.IngressSpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.IngressSpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", name: string, property: "status"): pulumi.Output<outputs.extensions.v1beta1.IngressStatus>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/Ingress", namespace: string, name: string, property: "status"): pulumi.Output<outputs.extensions.v1beta1.IngressStatus>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/IngressList", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/IngressList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/IngressList", name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.Ingress[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/IngressList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.Ingress[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/IngressList", name: string, property: "kind"): pulumi.Output<"IngressList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/IngressList", namespace: string, name: string, property: "kind"): pulumi.Output<"IngressList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/IngressList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/IngressList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicy", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicy", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicy", name: string, property: "kind"): pulumi.Output<"NetworkPolicy">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicy", namespace: string, name: string, property: "kind"): pulumi.Output<"NetworkPolicy">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicy", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicy", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicy", name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.NetworkPolicySpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicy", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.NetworkPolicySpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.NetworkPolicy[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.NetworkPolicy[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", name: string, property: "kind"): pulumi.Output<"NetworkPolicyList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", namespace: string, name: string, property: "kind"): pulumi.Output<"NetworkPolicyList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/NetworkPolicyList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", name: string, property: "kind"): pulumi.Output<"PodSecurityPolicy">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSecurityPolicy">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.PodSecurityPolicySpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicy", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.PodSecurityPolicySpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.PodSecurityPolicy[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.PodSecurityPolicy[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", name: string, property: "kind"): pulumi.Output<"PodSecurityPolicyList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSecurityPolicyList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/PodSecurityPolicyList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", name: string, property: "kind"): pulumi.Output<"ReplicaSet">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", namespace: string, name: string, property: "kind"): pulumi.Output<"ReplicaSet">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.ReplicaSetSpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.extensions.v1beta1.ReplicaSetSpec>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", name: string, property: "status"): pulumi.Output<outputs.extensions.v1beta1.ReplicaSetStatus>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSet", namespace: string, name: string, property: "status"): pulumi.Output<outputs.extensions.v1beta1.ReplicaSetStatus>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSetList", name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"extensions/v1beta1">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSetList", name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.ReplicaSet[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.extensions.v1beta1.ReplicaSet[]>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSetList", name: string, property: "kind"): pulumi.Output<"ReplicaSetList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSetList", namespace: string, name: string, property: "kind"): pulumi.Output<"ReplicaSetList">;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "extensions/v1beta1/ReplicaSetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchema", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/FlowSchemaList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfiguration", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1/PriorityLevelConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1alpha1.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1alpha1.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1alpha1.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchema", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1alpha1.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1alpha1.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1alpha1.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/FlowSchemaList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1alpha1.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1alpha1.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1alpha1.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfiguration", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1alpha1.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1alpha1.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1alpha1.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1alpha1/PriorityLevelConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta1.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta1.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta1.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchema", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta1.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta1.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta1.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/FlowSchemaList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta1.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta1.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta1.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfiguration", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta1.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta1.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta1.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta1/PriorityLevelConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta2.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta2.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta2.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchema", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta2.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta2.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta2.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/FlowSchemaList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta2.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta2.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta2.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfiguration", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta2.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta2.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta2.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta2/PriorityLevelConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta3">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta3">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchema">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta3.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta3.FlowSchemaSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta3.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchema", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta3.FlowSchemaStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta3">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta3">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta3.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta3.FlowSchema[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", namespace: string, name: string, property: "kind"): pulumi.Output<"FlowSchemaList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/FlowSchemaList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta3">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta3">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfiguration">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta3.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.flowcontrol.v1beta3.PriorityLevelConfigurationSpec>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta3.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfiguration", namespace: string, name: string, property: "status"): pulumi.Output<outputs.flowcontrol.v1beta3.PriorityLevelConfigurationStatus>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta3">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"flowcontrol.apiserver.k8s.io/v1beta3">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta3.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.flowcontrol.v1beta3.PriorityLevelConfiguration[]>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityLevelConfigurationList">;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "flowcontrol.apiserver.k8s.io/v1beta3/PriorityLevelConfigurationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "meta/v1/Status", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"v1">;
    getResourceProperty(groupVersionKind: "meta/v1/Status", name: string, property: "code"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", namespace: string, name: string, property: "code"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", name: string, property: "details"): pulumi.Output<outputs.meta.v1.StatusDetails>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", namespace: string, name: string, property: "details"): pulumi.Output<outputs.meta.v1.StatusDetails>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", name: string, property: "kind"): pulumi.Output<"Status">;
    getResourceProperty(groupVersionKind: "meta/v1/Status", namespace: string, name: string, property: "kind"): pulumi.Output<"Status">;
    getResourceProperty(groupVersionKind: "meta/v1/Status", name: string, property: "message"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", namespace: string, name: string, property: "message"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", name: string, property: "reason"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", namespace: string, name: string, property: "reason"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", name: string, property: "status"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "meta/v1/Status", namespace: string, name: string, property: "status"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddress", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddress", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddress", name: string, property: "kind"): pulumi.Output<"IPAddress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddress", namespace: string, name: string, property: "kind"): pulumi.Output<"IPAddress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddress", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddress", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddress", name: string, property: "spec"): pulumi.Output<outputs.networking.v1.IPAddressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddress", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1.IPAddressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddressList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddressList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddressList", name: string, property: "items"): pulumi.Output<outputs.networking.v1.IPAddress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddressList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1.IPAddress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddressList", name: string, property: "kind"): pulumi.Output<"IPAddressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddressList", namespace: string, name: string, property: "kind"): pulumi.Output<"IPAddressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddressList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IPAddressList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", name: string, property: "kind"): pulumi.Output<"Ingress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", namespace: string, name: string, property: "kind"): pulumi.Output<"Ingress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", name: string, property: "spec"): pulumi.Output<outputs.networking.v1.IngressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1.IngressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", name: string, property: "status"): pulumi.Output<outputs.networking.v1.IngressStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/Ingress", namespace: string, name: string, property: "status"): pulumi.Output<outputs.networking.v1.IngressStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClass", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClass", name: string, property: "kind"): pulumi.Output<"IngressClass">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClass", namespace: string, name: string, property: "kind"): pulumi.Output<"IngressClass">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClass", name: string, property: "spec"): pulumi.Output<outputs.networking.v1.IngressClassSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClass", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1.IngressClassSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClassList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClassList", name: string, property: "items"): pulumi.Output<outputs.networking.v1.IngressClass[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1.IngressClass[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClassList", name: string, property: "kind"): pulumi.Output<"IngressClassList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"IngressClassList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressList", name: string, property: "items"): pulumi.Output<outputs.networking.v1.Ingress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1.Ingress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressList", name: string, property: "kind"): pulumi.Output<"IngressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressList", namespace: string, name: string, property: "kind"): pulumi.Output<"IngressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/IngressList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", name: string, property: "kind"): pulumi.Output<"NetworkPolicy">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", namespace: string, name: string, property: "kind"): pulumi.Output<"NetworkPolicy">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", name: string, property: "spec"): pulumi.Output<outputs.networking.v1.NetworkPolicySpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1.NetworkPolicySpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", name: string, property: "status"): pulumi.Output<outputs.networking.v1.NetworkPolicyStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicy", namespace: string, name: string, property: "status"): pulumi.Output<outputs.networking.v1.NetworkPolicyStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", name: string, property: "items"): pulumi.Output<outputs.networking.v1.NetworkPolicy[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1.NetworkPolicy[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", name: string, property: "kind"): pulumi.Output<"NetworkPolicyList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", namespace: string, name: string, property: "kind"): pulumi.Output<"NetworkPolicyList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/NetworkPolicyList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", name: string, property: "kind"): pulumi.Output<"ServiceCIDR">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceCIDR">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", name: string, property: "spec"): pulumi.Output<outputs.networking.v1.ServiceCIDRSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1.ServiceCIDRSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", name: string, property: "status"): pulumi.Output<outputs.networking.v1.ServiceCIDRStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDR", namespace: string, name: string, property: "status"): pulumi.Output<outputs.networking.v1.ServiceCIDRStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", name: string, property: "items"): pulumi.Output<outputs.networking.v1.ServiceCIDR[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1.ServiceCIDR[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", name: string, property: "kind"): pulumi.Output<"ServiceCIDRList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceCIDRList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1/ServiceCIDRList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", name: string, property: "kind"): pulumi.Output<"ClusterCIDR">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterCIDR">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", name: string, property: "spec"): pulumi.Output<outputs.networking.v1alpha1.ClusterCIDRSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDR", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1alpha1.ClusterCIDRSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", name: string, property: "items"): pulumi.Output<outputs.networking.v1alpha1.ClusterCIDR[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1alpha1.ClusterCIDR[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", name: string, property: "kind"): pulumi.Output<"ClusterCIDRList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterCIDRList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ClusterCIDRList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", name: string, property: "kind"): pulumi.Output<"IPAddress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", namespace: string, name: string, property: "kind"): pulumi.Output<"IPAddress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", name: string, property: "spec"): pulumi.Output<outputs.networking.v1alpha1.IPAddressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddress", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1alpha1.IPAddressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", name: string, property: "items"): pulumi.Output<outputs.networking.v1alpha1.IPAddress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1alpha1.IPAddress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", name: string, property: "kind"): pulumi.Output<"IPAddressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", namespace: string, name: string, property: "kind"): pulumi.Output<"IPAddressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/IPAddressList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", name: string, property: "kind"): pulumi.Output<"ServiceCIDR">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceCIDR">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", name: string, property: "spec"): pulumi.Output<outputs.networking.v1alpha1.ServiceCIDRSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1alpha1.ServiceCIDRSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", name: string, property: "status"): pulumi.Output<outputs.networking.v1alpha1.ServiceCIDRStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDR", namespace: string, name: string, property: "status"): pulumi.Output<outputs.networking.v1alpha1.ServiceCIDRStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", name: string, property: "items"): pulumi.Output<outputs.networking.v1alpha1.ServiceCIDR[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1alpha1.ServiceCIDR[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", name: string, property: "kind"): pulumi.Output<"ServiceCIDRList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceCIDRList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1alpha1/ServiceCIDRList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", name: string, property: "kind"): pulumi.Output<"IPAddress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", namespace: string, name: string, property: "kind"): pulumi.Output<"IPAddress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", name: string, property: "spec"): pulumi.Output<outputs.networking.v1beta1.IPAddressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddress", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1beta1.IPAddressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", name: string, property: "items"): pulumi.Output<outputs.networking.v1beta1.IPAddress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1beta1.IPAddress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", name: string, property: "kind"): pulumi.Output<"IPAddressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", namespace: string, name: string, property: "kind"): pulumi.Output<"IPAddressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IPAddressList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", name: string, property: "kind"): pulumi.Output<"Ingress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", namespace: string, name: string, property: "kind"): pulumi.Output<"Ingress">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", name: string, property: "spec"): pulumi.Output<outputs.networking.v1beta1.IngressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1beta1.IngressSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", name: string, property: "status"): pulumi.Output<outputs.networking.v1beta1.IngressStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/Ingress", namespace: string, name: string, property: "status"): pulumi.Output<outputs.networking.v1beta1.IngressStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", name: string, property: "kind"): pulumi.Output<"IngressClass">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", namespace: string, name: string, property: "kind"): pulumi.Output<"IngressClass">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", name: string, property: "spec"): pulumi.Output<outputs.networking.v1beta1.IngressClassSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClass", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1beta1.IngressClassSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", name: string, property: "items"): pulumi.Output<outputs.networking.v1beta1.IngressClass[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1beta1.IngressClass[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", name: string, property: "kind"): pulumi.Output<"IngressClassList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"IngressClassList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", name: string, property: "items"): pulumi.Output<outputs.networking.v1beta1.Ingress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1beta1.Ingress[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", name: string, property: "kind"): pulumi.Output<"IngressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", namespace: string, name: string, property: "kind"): pulumi.Output<"IngressList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/IngressList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", name: string, property: "kind"): pulumi.Output<"ServiceCIDR">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceCIDR">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", name: string, property: "spec"): pulumi.Output<outputs.networking.v1beta1.ServiceCIDRSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.networking.v1beta1.ServiceCIDRSpec>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", name: string, property: "status"): pulumi.Output<outputs.networking.v1beta1.ServiceCIDRStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDR", namespace: string, name: string, property: "status"): pulumi.Output<outputs.networking.v1beta1.ServiceCIDRStatus>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"networking.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", name: string, property: "items"): pulumi.Output<outputs.networking.v1beta1.ServiceCIDR[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.networking.v1beta1.ServiceCIDR[]>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", name: string, property: "kind"): pulumi.Output<"ServiceCIDRList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", namespace: string, name: string, property: "kind"): pulumi.Output<"ServiceCIDRList">;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "networking.k8s.io/v1beta1/ServiceCIDRList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", name: string, property: "handler"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", namespace: string, name: string, property: "handler"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", name: string, property: "kind"): pulumi.Output<"RuntimeClass">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", namespace: string, name: string, property: "kind"): pulumi.Output<"RuntimeClass">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", name: string, property: "overhead"): pulumi.Output<outputs.node.v1.Overhead>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", namespace: string, name: string, property: "overhead"): pulumi.Output<outputs.node.v1.Overhead>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", name: string, property: "scheduling"): pulumi.Output<outputs.node.v1.Scheduling>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClass", namespace: string, name: string, property: "scheduling"): pulumi.Output<outputs.node.v1.Scheduling>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", name: string, property: "items"): pulumi.Output<outputs.node.v1.RuntimeClass[]>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.node.v1.RuntimeClass[]>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", name: string, property: "kind"): pulumi.Output<"RuntimeClassList">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"RuntimeClassList">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1/RuntimeClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", name: string, property: "kind"): pulumi.Output<"RuntimeClass">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", namespace: string, name: string, property: "kind"): pulumi.Output<"RuntimeClass">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", name: string, property: "spec"): pulumi.Output<outputs.node.v1alpha1.RuntimeClassSpec>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClass", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.node.v1alpha1.RuntimeClassSpec>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", name: string, property: "items"): pulumi.Output<outputs.node.v1alpha1.RuntimeClass[]>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.node.v1alpha1.RuntimeClass[]>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", name: string, property: "kind"): pulumi.Output<"RuntimeClassList">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"RuntimeClassList">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1alpha1/RuntimeClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", name: string, property: "handler"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", namespace: string, name: string, property: "handler"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", name: string, property: "kind"): pulumi.Output<"RuntimeClass">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", namespace: string, name: string, property: "kind"): pulumi.Output<"RuntimeClass">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", name: string, property: "overhead"): pulumi.Output<outputs.node.v1beta1.Overhead>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", namespace: string, name: string, property: "overhead"): pulumi.Output<outputs.node.v1beta1.Overhead>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", name: string, property: "scheduling"): pulumi.Output<outputs.node.v1beta1.Scheduling>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClass", namespace: string, name: string, property: "scheduling"): pulumi.Output<outputs.node.v1beta1.Scheduling>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"node.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", name: string, property: "items"): pulumi.Output<outputs.node.v1beta1.RuntimeClass[]>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.node.v1beta1.RuntimeClass[]>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", name: string, property: "kind"): pulumi.Output<"RuntimeClassList">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"RuntimeClassList">;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "node.k8s.io/v1beta1/RuntimeClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", name: string, property: "apiVersion"): pulumi.Output<"policy/v1">;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"policy/v1">;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", name: string, property: "kind"): pulumi.Output<"PodDisruptionBudget">;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", namespace: string, name: string, property: "kind"): pulumi.Output<"PodDisruptionBudget">;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", name: string, property: "spec"): pulumi.Output<outputs.policy.v1.PodDisruptionBudgetSpec>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.policy.v1.PodDisruptionBudgetSpec>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", name: string, property: "status"): pulumi.Output<outputs.policy.v1.PodDisruptionBudgetStatus>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudget", namespace: string, name: string, property: "status"): pulumi.Output<outputs.policy.v1.PodDisruptionBudgetStatus>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudgetList", name: string, property: "apiVersion"): pulumi.Output<"policy/v1">;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudgetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"policy/v1">;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudgetList", name: string, property: "items"): pulumi.Output<outputs.policy.v1.PodDisruptionBudget[]>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudgetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.policy.v1.PodDisruptionBudget[]>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudgetList", name: string, property: "kind"): pulumi.Output<"PodDisruptionBudgetList">;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudgetList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodDisruptionBudgetList">;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudgetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "policy/v1/PodDisruptionBudgetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", name: string, property: "apiVersion"): pulumi.Output<"policy/v1beta1">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"policy/v1beta1">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", name: string, property: "kind"): pulumi.Output<"PodDisruptionBudget">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", namespace: string, name: string, property: "kind"): pulumi.Output<"PodDisruptionBudget">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", name: string, property: "spec"): pulumi.Output<outputs.policy.v1beta1.PodDisruptionBudgetSpec>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.policy.v1beta1.PodDisruptionBudgetSpec>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", name: string, property: "status"): pulumi.Output<outputs.policy.v1beta1.PodDisruptionBudgetStatus>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudget", namespace: string, name: string, property: "status"): pulumi.Output<outputs.policy.v1beta1.PodDisruptionBudgetStatus>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", name: string, property: "apiVersion"): pulumi.Output<"policy/v1beta1">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"policy/v1beta1">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", name: string, property: "items"): pulumi.Output<outputs.policy.v1beta1.PodDisruptionBudget[]>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.policy.v1beta1.PodDisruptionBudget[]>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", name: string, property: "kind"): pulumi.Output<"PodDisruptionBudgetList">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodDisruptionBudgetList">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodDisruptionBudgetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", name: string, property: "apiVersion"): pulumi.Output<"policy/v1beta1">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"policy/v1beta1">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", name: string, property: "kind"): pulumi.Output<"PodSecurityPolicy">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSecurityPolicy">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", name: string, property: "spec"): pulumi.Output<outputs.policy.v1beta1.PodSecurityPolicySpec>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicy", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.policy.v1beta1.PodSecurityPolicySpec>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", name: string, property: "apiVersion"): pulumi.Output<"policy/v1beta1">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"policy/v1beta1">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", name: string, property: "items"): pulumi.Output<outputs.policy.v1beta1.PodSecurityPolicy[]>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.policy.v1beta1.PodSecurityPolicy[]>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", name: string, property: "kind"): pulumi.Output<"PodSecurityPolicyList">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSecurityPolicyList">;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "policy/v1beta1/PodSecurityPolicyList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", name: string, property: "aggregationRule"): pulumi.Output<outputs.rbac.v1.AggregationRule>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", namespace: string, name: string, property: "aggregationRule"): pulumi.Output<outputs.rbac.v1.AggregationRule>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", name: string, property: "kind"): pulumi.Output<"ClusterRole">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRole">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", name: string, property: "rules"): pulumi.Output<outputs.rbac.v1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRole", namespace: string, name: string, property: "rules"): pulumi.Output<outputs.rbac.v1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", name: string, property: "kind"): pulumi.Output<"ClusterRoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", namespace: string, name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBinding", namespace: string, name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1.ClusterRoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1.ClusterRoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", name: string, property: "kind"): pulumi.Output<"ClusterRoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1.ClusterRole[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1.ClusterRole[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", name: string, property: "kind"): pulumi.Output<"ClusterRoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/ClusterRoleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", name: string, property: "kind"): pulumi.Output<"Role">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", namespace: string, name: string, property: "kind"): pulumi.Output<"Role">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", name: string, property: "rules"): pulumi.Output<outputs.rbac.v1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/Role", namespace: string, name: string, property: "rules"): pulumi.Output<outputs.rbac.v1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", name: string, property: "kind"): pulumi.Output<"RoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", namespace: string, name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBinding", namespace: string, name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1.RoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1.RoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", name: string, property: "kind"): pulumi.Output<"RoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1.Role[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1.Role[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", name: string, property: "kind"): pulumi.Output<"RoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1/RoleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", name: string, property: "aggregationRule"): pulumi.Output<outputs.rbac.v1alpha1.AggregationRule>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", namespace: string, name: string, property: "aggregationRule"): pulumi.Output<outputs.rbac.v1alpha1.AggregationRule>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", name: string, property: "kind"): pulumi.Output<"ClusterRole">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRole">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", name: string, property: "rules"): pulumi.Output<outputs.rbac.v1alpha1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRole", namespace: string, name: string, property: "rules"): pulumi.Output<outputs.rbac.v1alpha1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", name: string, property: "kind"): pulumi.Output<"ClusterRoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1alpha1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", namespace: string, name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1alpha1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1alpha1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBinding", namespace: string, name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1alpha1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1alpha1.ClusterRoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1alpha1.ClusterRoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", name: string, property: "kind"): pulumi.Output<"ClusterRoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1alpha1.ClusterRole[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1alpha1.ClusterRole[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", name: string, property: "kind"): pulumi.Output<"ClusterRoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/ClusterRoleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", name: string, property: "kind"): pulumi.Output<"Role">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", namespace: string, name: string, property: "kind"): pulumi.Output<"Role">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", name: string, property: "rules"): pulumi.Output<outputs.rbac.v1alpha1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/Role", namespace: string, name: string, property: "rules"): pulumi.Output<outputs.rbac.v1alpha1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", name: string, property: "kind"): pulumi.Output<"RoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1alpha1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", namespace: string, name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1alpha1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1alpha1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBinding", namespace: string, name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1alpha1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1alpha1.RoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1alpha1.RoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", name: string, property: "kind"): pulumi.Output<"RoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1alpha1.Role[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1alpha1.Role[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", name: string, property: "kind"): pulumi.Output<"RoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1alpha1/RoleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", name: string, property: "aggregationRule"): pulumi.Output<outputs.rbac.v1beta1.AggregationRule>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", namespace: string, name: string, property: "aggregationRule"): pulumi.Output<outputs.rbac.v1beta1.AggregationRule>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", name: string, property: "kind"): pulumi.Output<"ClusterRole">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRole">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", name: string, property: "rules"): pulumi.Output<outputs.rbac.v1beta1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRole", namespace: string, name: string, property: "rules"): pulumi.Output<outputs.rbac.v1beta1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", name: string, property: "kind"): pulumi.Output<"ClusterRoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1beta1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", namespace: string, name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1beta1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1beta1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBinding", namespace: string, name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1beta1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1beta1.ClusterRoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1beta1.ClusterRoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", name: string, property: "kind"): pulumi.Output<"ClusterRoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1beta1.ClusterRole[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1beta1.ClusterRole[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", name: string, property: "kind"): pulumi.Output<"ClusterRoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", namespace: string, name: string, property: "kind"): pulumi.Output<"ClusterRoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/ClusterRoleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", name: string, property: "kind"): pulumi.Output<"Role">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", namespace: string, name: string, property: "kind"): pulumi.Output<"Role">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", name: string, property: "rules"): pulumi.Output<outputs.rbac.v1beta1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/Role", namespace: string, name: string, property: "rules"): pulumi.Output<outputs.rbac.v1beta1.PolicyRule[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", name: string, property: "kind"): pulumi.Output<"RoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleBinding">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1beta1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", namespace: string, name: string, property: "roleRef"): pulumi.Output<outputs.rbac.v1beta1.RoleRef>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1beta1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBinding", namespace: string, name: string, property: "subjects"): pulumi.Output<outputs.rbac.v1beta1.Subject[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1beta1.RoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1beta1.RoleBinding[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", name: string, property: "kind"): pulumi.Output<"RoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleBindingList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleBindingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"rbac.authorization.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", name: string, property: "items"): pulumi.Output<outputs.rbac.v1beta1.Role[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.rbac.v1beta1.Role[]>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", name: string, property: "kind"): pulumi.Output<"RoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", namespace: string, name: string, property: "kind"): pulumi.Output<"RoleList">;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "rbac.authorization.k8s.io/v1beta1/RoleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", name: string, property: "kind"): pulumi.Output<"PodScheduling">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", namespace: string, name: string, property: "kind"): pulumi.Output<"PodScheduling">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha1.PodSchedulingSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha1.PodSchedulingSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha1.PodSchedulingStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodScheduling", namespace: string, name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha1.PodSchedulingStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha1.PodScheduling[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha1.PodScheduling[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", name: string, property: "kind"): pulumi.Output<"PodSchedulingList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSchedulingList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/PodSchedulingList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaim", namespace: string, name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplate", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha1.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClaimTemplateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", namespace: string, name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", name: string, property: "kind"): pulumi.Output<"ResourceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", name: string, property: "parametersRef"): pulumi.Output<outputs.resource.v1alpha1.ResourceClassParametersReference>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", namespace: string, name: string, property: "parametersRef"): pulumi.Output<outputs.resource.v1alpha1.ResourceClassParametersReference>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", name: string, property: "suitableNodes"): pulumi.Output<outputs.core.v1.NodeSelector>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClass", namespace: string, name: string, property: "suitableNodes"): pulumi.Output<outputs.core.v1.NodeSelector>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha1.ResourceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha1.ResourceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", name: string, property: "kind"): pulumi.Output<"ResourceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha1/ResourceClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", name: string, property: "kind"): pulumi.Output<"PodSchedulingContext">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSchedulingContext">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha2.PodSchedulingContextSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha2.PodSchedulingContextSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha2.PodSchedulingContextStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContext", namespace: string, name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha2.PodSchedulingContextStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.PodSchedulingContext[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.PodSchedulingContext[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", name: string, property: "kind"): pulumi.Output<"PodSchedulingContextList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSchedulingContextList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/PodSchedulingContextList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaim", namespace: string, name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", name: string, property: "driverRequests"): pulumi.Output<outputs.resource.v1alpha2.DriverRequests[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", namespace: string, name: string, property: "driverRequests"): pulumi.Output<outputs.resource.v1alpha2.DriverRequests[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", name: string, property: "generatedFrom"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimParametersReference>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", namespace: string, name: string, property: "generatedFrom"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimParametersReference>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", name: string, property: "kind"): pulumi.Output<"ResourceClaimParameters">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimParameters">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", name: string, property: "shareable"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParameters", namespace: string, name: string, property: "shareable"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimParameters[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimParameters[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", name: string, property: "kind"): pulumi.Output<"ResourceClaimParametersList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimParametersList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimParametersList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplate", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClaimTemplateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", namespace: string, name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", name: string, property: "kind"): pulumi.Output<"ResourceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", name: string, property: "parametersRef"): pulumi.Output<outputs.resource.v1alpha2.ResourceClassParametersReference>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", namespace: string, name: string, property: "parametersRef"): pulumi.Output<outputs.resource.v1alpha2.ResourceClassParametersReference>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", name: string, property: "structuredParameters"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", namespace: string, name: string, property: "structuredParameters"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", name: string, property: "suitableNodes"): pulumi.Output<outputs.core.v1.NodeSelector>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClass", namespace: string, name: string, property: "suitableNodes"): pulumi.Output<outputs.core.v1.NodeSelector>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", name: string, property: "kind"): pulumi.Output<"ResourceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", name: string, property: "filters"): pulumi.Output<outputs.resource.v1alpha2.ResourceFilter[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", namespace: string, name: string, property: "filters"): pulumi.Output<outputs.resource.v1alpha2.ResourceFilter[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", name: string, property: "generatedFrom"): pulumi.Output<outputs.resource.v1alpha2.ResourceClassParametersReference>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", namespace: string, name: string, property: "generatedFrom"): pulumi.Output<outputs.resource.v1alpha2.ResourceClassParametersReference>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", name: string, property: "kind"): pulumi.Output<"ResourceClassParameters">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClassParameters">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", name: string, property: "vendorParameters"): pulumi.Output<outputs.resource.v1alpha2.VendorParameters[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParameters", namespace: string, name: string, property: "vendorParameters"): pulumi.Output<outputs.resource.v1alpha2.VendorParameters[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClassParameters[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceClassParameters[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", name: string, property: "kind"): pulumi.Output<"ResourceClassParametersList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClassParametersList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceClassParametersList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", namespace: string, name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", name: string, property: "kind"): pulumi.Output<"ResourceSlice">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceSlice">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", name: string, property: "namedResources"): pulumi.Output<outputs.resource.v1alpha2.NamedResourcesResources>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", namespace: string, name: string, property: "namedResources"): pulumi.Output<outputs.resource.v1alpha2.NamedResourcesResources>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", name: string, property: "nodeName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSlice", namespace: string, name: string, property: "nodeName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceSlice[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha2.ResourceSlice[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", name: string, property: "kind"): pulumi.Output<"ResourceSliceList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceSliceList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha2/ResourceSliceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", name: string, property: "kind"): pulumi.Output<"DeviceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", namespace: string, name: string, property: "kind"): pulumi.Output<"DeviceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.DeviceClassSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClass", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.DeviceClassSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.DeviceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.DeviceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", name: string, property: "kind"): pulumi.Output<"DeviceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"DeviceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", name: string, property: "kind"): pulumi.Output<"DeviceTaintRule">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", namespace: string, name: string, property: "kind"): pulumi.Output<"DeviceTaintRule">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.DeviceTaintRuleSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRule", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.DeviceTaintRuleSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.DeviceTaintRule[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.DeviceTaintRule[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", name: string, property: "kind"): pulumi.Output<"DeviceTaintRuleList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", namespace: string, name: string, property: "kind"): pulumi.Output<"DeviceTaintRuleList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/DeviceTaintRuleList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", name: string, property: "kind"): pulumi.Output<"PodSchedulingContext">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSchedulingContext">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.PodSchedulingContextSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.PodSchedulingContextSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha3.PodSchedulingContextStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContext", namespace: string, name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha3.PodSchedulingContextStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.PodSchedulingContext[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.PodSchedulingContext[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", name: string, property: "kind"): pulumi.Output<"PodSchedulingContextList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodSchedulingContextList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/PodSchedulingContextList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaim", namespace: string, name: string, property: "status"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplate", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceClaimTemplateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", name: string, property: "kind"): pulumi.Output<"ResourceSlice">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceSlice">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.ResourceSliceSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSlice", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1alpha3.ResourceSliceSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1alpha3">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.ResourceSlice[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1alpha3.ResourceSlice[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", name: string, property: "kind"): pulumi.Output<"ResourceSliceList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceSliceList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", name: string, property: "listMeta"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", namespace: string, name: string, property: "listMeta"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1alpha3/ResourceSliceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", name: string, property: "kind"): pulumi.Output<"DeviceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", namespace: string, name: string, property: "kind"): pulumi.Output<"DeviceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta1.DeviceClassSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClass", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta1.DeviceClassSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", name: string, property: "items"): pulumi.Output<outputs.resource.v1beta1.DeviceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1beta1.DeviceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", name: string, property: "kind"): pulumi.Output<"DeviceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"DeviceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/DeviceClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta1.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta1.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", name: string, property: "status"): pulumi.Output<outputs.resource.v1beta1.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaim", namespace: string, name: string, property: "status"): pulumi.Output<outputs.resource.v1beta1.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", name: string, property: "items"): pulumi.Output<outputs.resource.v1beta1.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1beta1.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta1.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplate", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta1.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", name: string, property: "items"): pulumi.Output<outputs.resource.v1beta1.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1beta1.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceClaimTemplateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", name: string, property: "kind"): pulumi.Output<"ResourceSlice">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceSlice">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta1.ResourceSliceSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSlice", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta1.ResourceSliceSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", name: string, property: "items"): pulumi.Output<outputs.resource.v1beta1.ResourceSlice[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1beta1.ResourceSlice[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", name: string, property: "kind"): pulumi.Output<"ResourceSliceList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceSliceList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta1/ResourceSliceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", name: string, property: "kind"): pulumi.Output<"DeviceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", namespace: string, name: string, property: "kind"): pulumi.Output<"DeviceClass">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta2.DeviceClassSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClass", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta2.DeviceClassSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", name: string, property: "items"): pulumi.Output<outputs.resource.v1beta2.DeviceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1beta2.DeviceClass[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", name: string, property: "kind"): pulumi.Output<"DeviceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"DeviceClassList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/DeviceClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaim">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta2.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta2.ResourceClaimSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", name: string, property: "status"): pulumi.Output<outputs.resource.v1beta2.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaim", namespace: string, name: string, property: "status"): pulumi.Output<outputs.resource.v1beta2.ResourceClaimStatus>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", name: string, property: "items"): pulumi.Output<outputs.resource.v1beta2.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1beta2.ResourceClaim[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplate">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta2.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplate", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta2.ResourceClaimTemplateSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", name: string, property: "items"): pulumi.Output<outputs.resource.v1beta2.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1beta2.ResourceClaimTemplate[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceClaimTemplateList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceClaimTemplateList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", name: string, property: "kind"): pulumi.Output<"ResourceSlice">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceSlice">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta2.ResourceSliceSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSlice", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.resource.v1beta2.ResourceSliceSpec>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"resource.k8s.io/v1beta2">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", name: string, property: "items"): pulumi.Output<outputs.resource.v1beta2.ResourceSlice[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.resource.v1beta2.ResourceSlice[]>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", name: string, property: "kind"): pulumi.Output<"ResourceSliceList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", namespace: string, name: string, property: "kind"): pulumi.Output<"ResourceSliceList">;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "resource.k8s.io/v1beta2/ResourceSliceList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", name: string, property: "description"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", namespace: string, name: string, property: "description"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", name: string, property: "globalDefault"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", namespace: string, name: string, property: "globalDefault"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", name: string, property: "kind"): pulumi.Output<"PriorityClass">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityClass">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", name: string, property: "preemptionPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", namespace: string, name: string, property: "preemptionPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", name: string, property: "value"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClass", namespace: string, name: string, property: "value"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", name: string, property: "items"): pulumi.Output<outputs.scheduling.v1.PriorityClass[]>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.scheduling.v1.PriorityClass[]>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", name: string, property: "kind"): pulumi.Output<"PriorityClassList">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityClassList">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1/PriorityClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", name: string, property: "description"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", namespace: string, name: string, property: "description"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", name: string, property: "globalDefault"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", namespace: string, name: string, property: "globalDefault"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", name: string, property: "kind"): pulumi.Output<"PriorityClass">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityClass">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", name: string, property: "preemptionPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", namespace: string, name: string, property: "preemptionPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", name: string, property: "value"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClass", namespace: string, name: string, property: "value"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", name: string, property: "items"): pulumi.Output<outputs.scheduling.v1alpha1.PriorityClass[]>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.scheduling.v1alpha1.PriorityClass[]>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", name: string, property: "kind"): pulumi.Output<"PriorityClassList">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityClassList">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1alpha1/PriorityClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", name: string, property: "description"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", namespace: string, name: string, property: "description"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", name: string, property: "globalDefault"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", namespace: string, name: string, property: "globalDefault"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", name: string, property: "kind"): pulumi.Output<"PriorityClass">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityClass">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", name: string, property: "preemptionPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", namespace: string, name: string, property: "preemptionPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", name: string, property: "value"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClass", namespace: string, name: string, property: "value"): pulumi.Output<number>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"scheduling.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", name: string, property: "items"): pulumi.Output<outputs.scheduling.v1beta1.PriorityClass[]>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.scheduling.v1beta1.PriorityClass[]>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", name: string, property: "kind"): pulumi.Output<"PriorityClassList">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"PriorityClassList">;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "scheduling.k8s.io/v1beta1/PriorityClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", name: string, property: "apiVersion"): pulumi.Output<"settings.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"settings.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", name: string, property: "kind"): pulumi.Output<"PodPreset">;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", namespace: string, name: string, property: "kind"): pulumi.Output<"PodPreset">;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", name: string, property: "spec"): pulumi.Output<outputs.settings.v1alpha1.PodPresetSpec>;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPreset", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.settings.v1alpha1.PodPresetSpec>;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", name: string, property: "apiVersion"): pulumi.Output<"settings.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"settings.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", name: string, property: "items"): pulumi.Output<outputs.settings.v1alpha1.PodPreset[]>;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.settings.v1alpha1.PodPreset[]>;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", name: string, property: "kind"): pulumi.Output<"PodPresetList">;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", namespace: string, name: string, property: "kind"): pulumi.Output<"PodPresetList">;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "settings.k8s.io/v1alpha1/PodPresetList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriver", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriver", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriver", name: string, property: "kind"): pulumi.Output<"CSIDriver">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriver", namespace: string, name: string, property: "kind"): pulumi.Output<"CSIDriver">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriver", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriver", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriver", name: string, property: "spec"): pulumi.Output<outputs.storage.v1.CSIDriverSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriver", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.storage.v1.CSIDriverSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", name: string, property: "items"): pulumi.Output<outputs.storage.v1.CSIDriver[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1.CSIDriver[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", name: string, property: "kind"): pulumi.Output<"CSIDriverList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", namespace: string, name: string, property: "kind"): pulumi.Output<"CSIDriverList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIDriverList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINode", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINode", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINode", name: string, property: "kind"): pulumi.Output<"CSINode">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINode", namespace: string, name: string, property: "kind"): pulumi.Output<"CSINode">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINode", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINode", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINode", name: string, property: "spec"): pulumi.Output<outputs.storage.v1.CSINodeSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINode", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.storage.v1.CSINodeSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINodeList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINodeList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINodeList", name: string, property: "items"): pulumi.Output<outputs.storage.v1.CSINode[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINodeList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1.CSINode[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINodeList", name: string, property: "kind"): pulumi.Output<"CSINodeList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINodeList", namespace: string, name: string, property: "kind"): pulumi.Output<"CSINodeList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINodeList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSINodeList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", name: string, property: "capacity"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", namespace: string, name: string, property: "capacity"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", name: string, property: "kind"): pulumi.Output<"CSIStorageCapacity">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", namespace: string, name: string, property: "kind"): pulumi.Output<"CSIStorageCapacity">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", name: string, property: "maximumVolumeSize"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", namespace: string, name: string, property: "maximumVolumeSize"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", name: string, property: "nodeTopology"): pulumi.Output<outputs.meta.v1.LabelSelector>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", namespace: string, name: string, property: "nodeTopology"): pulumi.Output<outputs.meta.v1.LabelSelector>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", name: string, property: "storageClassName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacity", namespace: string, name: string, property: "storageClassName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", name: string, property: "items"): pulumi.Output<outputs.storage.v1.CSIStorageCapacity[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1.CSIStorageCapacity[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", name: string, property: "kind"): pulumi.Output<"CSIStorageCapacityList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", namespace: string, name: string, property: "kind"): pulumi.Output<"CSIStorageCapacityList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/CSIStorageCapacityList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "allowVolumeExpansion"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "allowVolumeExpansion"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "allowedTopologies"): pulumi.Output<outputs.core.v1.TopologySelectorTerm[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "allowedTopologies"): pulumi.Output<outputs.core.v1.TopologySelectorTerm[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "kind"): pulumi.Output<"StorageClass">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "kind"): pulumi.Output<"StorageClass">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "mountOptions"): pulumi.Output<string[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "mountOptions"): pulumi.Output<string[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "parameters"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "parameters"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "provisioner"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "provisioner"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "reclaimPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "reclaimPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", name: string, property: "volumeBindingMode"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClass", namespace: string, name: string, property: "volumeBindingMode"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClassList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClassList", name: string, property: "items"): pulumi.Output<outputs.storage.v1.StorageClass[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1.StorageClass[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClassList", name: string, property: "kind"): pulumi.Output<"StorageClassList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"StorageClassList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/StorageClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", name: string, property: "kind"): pulumi.Output<"VolumeAttachment">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttachment">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", name: string, property: "spec"): pulumi.Output<outputs.storage.v1.VolumeAttachmentSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.storage.v1.VolumeAttachmentSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", name: string, property: "status"): pulumi.Output<outputs.storage.v1.VolumeAttachmentStatus>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachment", namespace: string, name: string, property: "status"): pulumi.Output<outputs.storage.v1.VolumeAttachmentStatus>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", name: string, property: "items"): pulumi.Output<outputs.storage.v1.VolumeAttachment[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1.VolumeAttachment[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", name: string, property: "kind"): pulumi.Output<"VolumeAttachmentList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttachmentList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1/VolumeAttachmentList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", name: string, property: "kind"): pulumi.Output<"VolumeAttachment">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttachment">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", name: string, property: "spec"): pulumi.Output<outputs.storage.v1alpha1.VolumeAttachmentSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.storage.v1alpha1.VolumeAttachmentSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", name: string, property: "status"): pulumi.Output<outputs.storage.v1alpha1.VolumeAttachmentStatus>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachment", namespace: string, name: string, property: "status"): pulumi.Output<outputs.storage.v1alpha1.VolumeAttachmentStatus>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", name: string, property: "items"): pulumi.Output<outputs.storage.v1alpha1.VolumeAttachment[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1alpha1.VolumeAttachment[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", name: string, property: "kind"): pulumi.Output<"VolumeAttachmentList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttachmentList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttachmentList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", namespace: string, name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", name: string, property: "kind"): pulumi.Output<"VolumeAttributesClass">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttributesClass">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", name: string, property: "parameters"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClass", namespace: string, name: string, property: "parameters"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", name: string, property: "items"): pulumi.Output<outputs.storage.v1alpha1.VolumeAttributesClass[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1alpha1.VolumeAttributesClass[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", name: string, property: "kind"): pulumi.Output<"VolumeAttributesClassList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttributesClassList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1alpha1/VolumeAttributesClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", name: string, property: "kind"): pulumi.Output<"CSIDriver">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", namespace: string, name: string, property: "kind"): pulumi.Output<"CSIDriver">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", name: string, property: "spec"): pulumi.Output<outputs.storage.v1beta1.CSIDriverSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriver", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.storage.v1beta1.CSIDriverSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.CSIDriver[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.CSIDriver[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", name: string, property: "kind"): pulumi.Output<"CSIDriverList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", namespace: string, name: string, property: "kind"): pulumi.Output<"CSIDriverList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIDriverList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", name: string, property: "kind"): pulumi.Output<"CSINode">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", namespace: string, name: string, property: "kind"): pulumi.Output<"CSINode">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", name: string, property: "spec"): pulumi.Output<outputs.storage.v1beta1.CSINodeSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINode", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.storage.v1beta1.CSINodeSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.CSINode[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.CSINode[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", name: string, property: "kind"): pulumi.Output<"CSINodeList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", namespace: string, name: string, property: "kind"): pulumi.Output<"CSINodeList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSINodeList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", name: string, property: "capacity"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", namespace: string, name: string, property: "capacity"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", name: string, property: "kind"): pulumi.Output<"CSIStorageCapacity">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", namespace: string, name: string, property: "kind"): pulumi.Output<"CSIStorageCapacity">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", name: string, property: "maximumVolumeSize"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", namespace: string, name: string, property: "maximumVolumeSize"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", name: string, property: "nodeTopology"): pulumi.Output<outputs.meta.v1.LabelSelector>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", namespace: string, name: string, property: "nodeTopology"): pulumi.Output<outputs.meta.v1.LabelSelector>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", name: string, property: "storageClassName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacity", namespace: string, name: string, property: "storageClassName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.CSIStorageCapacity[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.CSIStorageCapacity[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", name: string, property: "kind"): pulumi.Output<"CSIStorageCapacityList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", namespace: string, name: string, property: "kind"): pulumi.Output<"CSIStorageCapacityList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/CSIStorageCapacityList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "allowVolumeExpansion"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "allowVolumeExpansion"): pulumi.Output<boolean>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "allowedTopologies"): pulumi.Output<outputs.core.v1.TopologySelectorTerm[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "allowedTopologies"): pulumi.Output<outputs.core.v1.TopologySelectorTerm[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "kind"): pulumi.Output<"StorageClass">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "kind"): pulumi.Output<"StorageClass">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "mountOptions"): pulumi.Output<string[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "mountOptions"): pulumi.Output<string[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "parameters"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "parameters"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "provisioner"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "provisioner"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "reclaimPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "reclaimPolicy"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", name: string, property: "volumeBindingMode"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClass", namespace: string, name: string, property: "volumeBindingMode"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.StorageClass[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.StorageClass[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", name: string, property: "kind"): pulumi.Output<"StorageClassList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"StorageClassList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/StorageClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", name: string, property: "kind"): pulumi.Output<"VolumeAttachment">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttachment">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", name: string, property: "spec"): pulumi.Output<outputs.storage.v1beta1.VolumeAttachmentSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.storage.v1beta1.VolumeAttachmentSpec>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", name: string, property: "status"): pulumi.Output<outputs.storage.v1beta1.VolumeAttachmentStatus>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachment", namespace: string, name: string, property: "status"): pulumi.Output<outputs.storage.v1beta1.VolumeAttachmentStatus>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.VolumeAttachment[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.VolumeAttachment[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", name: string, property: "kind"): pulumi.Output<"VolumeAttachmentList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttachmentList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttachmentList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", namespace: string, name: string, property: "driverName"): pulumi.Output<string>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", name: string, property: "kind"): pulumi.Output<"VolumeAttributesClass">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttributesClass">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", name: string, property: "parameters"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClass", namespace: string, name: string, property: "parameters"): pulumi.Output<{
        [key: string]: string;
    }>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storage.k8s.io/v1beta1">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.VolumeAttributesClass[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storage.v1beta1.VolumeAttributesClass[]>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", name: string, property: "kind"): pulumi.Output<"VolumeAttributesClassList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", namespace: string, name: string, property: "kind"): pulumi.Output<"VolumeAttributesClassList">;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storage.k8s.io/v1beta1/VolumeAttributesClassList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", name: string, property: "apiVersion"): pulumi.Output<"storagemigration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storagemigration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", name: string, property: "kind"): pulumi.Output<"StorageVersionMigration">;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", namespace: string, name: string, property: "kind"): pulumi.Output<"StorageVersionMigration">;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ObjectMeta>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", name: string, property: "spec"): pulumi.Output<outputs.storagemigration.v1alpha1.StorageVersionMigrationSpec>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", namespace: string, name: string, property: "spec"): pulumi.Output<outputs.storagemigration.v1alpha1.StorageVersionMigrationSpec>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", name: string, property: "status"): pulumi.Output<outputs.storagemigration.v1alpha1.StorageVersionMigrationStatus>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigration", namespace: string, name: string, property: "status"): pulumi.Output<outputs.storagemigration.v1alpha1.StorageVersionMigrationStatus>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", name: string, property: "apiVersion"): pulumi.Output<"storagemigration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", namespace: string, name: string, property: "apiVersion"): pulumi.Output<"storagemigration.k8s.io/v1alpha1">;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", name: string, property: "items"): pulumi.Output<outputs.storagemigration.v1alpha1.StorageVersionMigration[]>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", namespace: string, name: string, property: "items"): pulumi.Output<outputs.storagemigration.v1alpha1.StorageVersionMigration[]>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", name: string, property: "kind"): pulumi.Output<"StorageVersionMigrationList">;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", namespace: string, name: string, property: "kind"): pulumi.Output<"StorageVersionMigrationList">;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    getResourceProperty(groupVersionKind: "storagemigration.k8s.io/v1alpha1/StorageVersionMigrationList", namespace: string, name: string, property: "metadata"): pulumi.Output<outputs.meta.v1.ListMeta>;
    /**
     * getCustomResource returns a resource defined by a CRD with the given group/version/kind and name.
     *
     * For example:
     *     getCustomResource("monitoring.coreos.com/v1/ServiceMonitor", "kube-prometheus-exporter-kubernetes")
     */
    getCustomResource<T extends pulumi.CustomResource>(groupVersionKind: string, namespace: string): pulumi.Output<T>;
    getCustomResource<T extends pulumi.CustomResource>(groupVersionKind: string, namespace: string, name: string): pulumi.Output<T>;
    private getResourceImpl;
}
/**
 * ConfigGroup creates a set of Kubernetes resources from Kubernetes YAML text. The YAML text
 * may be supplied using any of the following `ConfigGroupOpts`:
 *
 *   1. Using a filename or a list of filenames:
 *        a. `{files: "foo.yaml"}`
 *        b. `{files: ["foo.yaml", "bar.yaml"]}`
 *   2. Using a file pattern or a list of file patterns:
 *        a. `{files: "*.yaml"}`
 *        b. `{files: ["foo/*.yaml", "bar/*.yaml"]}`
 *   3. Using a literal string containing YAML, or a list of such strings:
 *        a. `{yaml: "(LITERAL YAML HERE)"}`
 *        b. `{yaml: ["(LITERAL YAML HERE)", "(MORE YAML)"]}`
 *   4. Any combination of files, patterns, or YAML strings:
 *        a. `{files: "foo.yaml", yaml: "(LITERAL YAML HERE)"}`
 *
 * ## Example Usage
 * ### Local File
 *
 * ```typescript
 * import * as k8s from "@pulumi/kubernetes";
 *
 * const example = new k8s.yaml.ConfigGroup("example", {
 *   files: "foo.yaml",
 * });
 * ```
 * ### Multiple Local Files
 *
 * ```typescript
 * import * as k8s from "@pulumi/kubernetes";
 *
 * const example = new k8s.yaml.ConfigGroup("example", {
 *   files: ["foo.yaml", "bar.yaml"],
 * });
 * ```
 * ### Local File Pattern
 *
 * ```typescript
 * import * as k8s from "@pulumi/kubernetes";
 *
 * const example = new k8s.yaml.ConfigGroup("example", {
 *   files: "yaml/*.yaml",
 * });
 * ```
 * ### Multiple Local File Patterns
 *
 * ```typescript
 * import * as k8s from "@pulumi/kubernetes";
 *
 * const example = new k8s.yaml.ConfigGroup("example", {
 *   files: ["foo/*.yaml", "bar/*.yaml"],
 * });
 * ```
 * ### Literal YAML String
 *
 * ```typescript
 * import * as k8s from "@pulumi/kubernetes";
 *
 * const example = new k8s.yaml.ConfigGroup("example", {
 *   yaml: `
 * apiVersion: v1
 * kind: Namespace
 * metadata:
 *   name: foo
 * `,
 * })
 * ```
 * ### YAML with Transformations
 *
 * ```typescript
 * import * as k8s from "@pulumi/kubernetes";
 *
 * const example = new k8s.yaml.ConfigGroup("example", {
 *   files: "foo.yaml",
 *   transformations: [
 *     // Make every service private to the cluster, i.e., turn all services into ClusterIP instead of LoadBalancer.
 *     (obj: any, opts: pulumi.CustomResourceOptions) => {
 *       if (obj.kind === "Service" && obj.apiVersion === "v1") {
 *         if (obj.spec && obj.spec.type && obj.spec.type === "LoadBalancer") {
 *           obj.spec.type = "ClusterIP";
 *         }
 *       }
 *     },
 *
 *     // Set a resource alias for a previous name.
 *     (obj: any, opts: pulumi.CustomResourceOptions) => {
 *     if (obj.kind === "Deployment") {
 *       opts.aliases = [{ name: "oldName" }]
 *     },
 *
 *     // Omit a resource from the Chart by transforming the specified resource definition to an empty List.
 *     (obj: any, opts: pulumi.CustomResourceOptions) => {
 *     if (obj.kind === "Pod" && obj.metadata.name === "test") {
 *       obj.apiVersion = "v1"
 *       obj.kind = "List"
 *     },
 *   ],
 * });
 * ```
 */
export declare class ConfigGroup extends CollectionComponentResource {
    /**
     * Create a ConfigGroup resource with the given unique name, arguments, and options.
     *
     * @param name The _unique_ name of the resource.
     * @param config The arguments to use to populate this resource's properties.
     * @param opts A bag of options that control this resource's behavior.
     */
    constructor(name: string, config: ConfigGroupOpts, opts?: pulumi.ComponentResourceOptions);
}
/**
 * ConfigFile creates a set of Kubernetes resources from Kubernetes YAML file. If `config.name`
 * is not specified, `ConfigFile` assumes the argument `name` is the filename.
 *
 * ## Example Usage
 * ### Local File
 *
 * ```typescript
 * import * as k8s from "@pulumi/kubernetes";
 *
 * const example = new k8s.yaml.ConfigFile("example", {
 *   file: "foo.yaml",
 * });
 * ```
 * ### YAML with Transformations
 *
 * ```typescript
 * import * as k8s from "@pulumi/kubernetes";
 *
 * const example = new k8s.yaml.ConfigFile("example", {
 *   file: "foo.yaml",
 *   transformations: [
 *     // Make every service private to the cluster, i.e., turn all services into ClusterIP instead of LoadBalancer.
 *     (obj: any, opts: pulumi.CustomResourceOptions) => {
 *       if (obj.kind === "Service" && obj.apiVersion === "v1") {
 *         if (obj.spec && obj.spec.type && obj.spec.type === "LoadBalancer") {
 *           obj.spec.type = "ClusterIP";
 *         }
 *       }
 *     },
 *
 *     // Set a resource alias for a previous name.
 *     (obj: any, opts: pulumi.CustomResourceOptions) => {
 *       if (obj.kind === "Deployment") {
 *         opts.aliases = [{name: "oldName"}]
 *       }
 *     },
 *
 *     // Omit a resource from the Chart by transforming the specified resource definition to an empty List.
 *     (obj: any, opts: pulumi.CustomResourceOptions) => {
 *       if (obj.kind === "Pod" && obj.metadata.name === "test") {
 *         obj.apiVersion = "v1"
 *         obj.kind = "List"
 *       }
 *     },
 *   ],
 * });
 * ```
 */
export declare class ConfigFile extends CollectionComponentResource {
    /**
     * Create a ConfigFile resource with the given unique name, arguments, and options.
     *
     * @param name The _unique_ name of the resource.
     * @param config The arguments to use to populate this resource's properties.
     * @param opts A bag of options that control this resource's behavior.
     */
    constructor(name: string, config?: ConfigFileOpts, opts?: pulumi.ComponentResourceOptions);
}
/**
 * The set of arguments for constructing a ConfigGroup resource.
 */
export interface ConfigGroupOpts {
    /** Set of paths or a URLs that uniquely identify files. */
    files?: string[] | string;
    /** YAML text containing Kubernetes resource definitions. */
    yaml?: string[] | string;
    /** JavaScript objects representing Kubernetes resources. */
    objs?: any[] | any;
    /** A set of transformations to apply to Kubernetes resource definitions before registering with engine. */
    transformations?: ((o: any, opts: pulumi.CustomResourceOptions) => void)[];
    /**
     * An optional prefix for the auto-generated resource names.
     * Example: A resource created with resourcePrefix="foo" would produce a resource named "foo-resourceName".
     */
    resourcePrefix?: string;
    /**
     * Skip await logic for all resources in this YAML. Resources will be marked ready as soon as they are created.
     * Warning: This option should not be used if you have resources depending on Outputs from the YAML.
     */
    skipAwait?: boolean;
}
/**
 * The set of arguments for constructing a ConfigFile resource.
 */
export interface ConfigFileOpts {
    /** Path or a URL that uniquely identifies a file. */
    file?: string;
    /** A set of transformations to apply to Kubernetes resource definitions before registering with engine. */
    transformations?: ((o: any, opts: pulumi.CustomResourceOptions) => void)[];
    /**
     * An optional prefix for the auto-generated resource names.
     * Example: A resource created with resourcePrefix="foo" would produce a resource named "foo-resourceName".
     */
    resourcePrefix?: string;
    /**
     * Skip await logic for all resources in this YAML. Resources will be marked ready as soon as they are created.
     * Warning: This option should not be used if you have resources depending on Outputs from the YAML.
     */
    skipAwait?: boolean;
}
/**
 * The set of arguments common to the ConfigFile and ConfigGroup resources.
 */
export interface ConfigOpts {
    /** JavaScript objects representing Kubernetes resources. */
    objs: Promise<any[]>;
    /** A set of transformations to apply to Kubernetes resource definitions before registering with engine. */
    transformations?: ((o: any, opts: pulumi.CustomResourceOptions) => void)[];
    /**
     * An optional prefix for the auto-generated resource names.
     * Example: A resource created with resourcePrefix="foo" would produce a resource named "foo-resourceName".
     */
    resourcePrefix?: string;
}
/** @ignore */ export declare function getChildOpts(parent: pulumi.Resource, opts?: pulumi.ComponentResourceOptions): pulumi.CustomResourceOptions;
/** @ignore */ export declare function getInvokeOpts(opts?: pulumi.CustomResourceOptions): pulumi.InvokeOptions;
/** @ignore */ export declare function skipAwait(o: any, opts: pulumi.ComponentResourceOptions): void;
/** @ignore */ export declare function parse(config: ConfigGroupOpts, opts?: pulumi.CustomResourceOptions): pulumi.Output<{
    [key: string]: pulumi.CustomResource;
}>;
